# Table structure for table 'lang_base'
#

CREATE TABLE `lang_base` (
  `variable` varchar(30) NOT NULL default '',
  `key` varchar(50) NOT NULL default '',
  `text` text NOT NULL,
  `revised_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `context` text NOT NULL,
  PRIMARY KEY  (`variable`,`key`)
) TYPE=MyISAM;

INSERT INTO `lang_base` VALUES ('_msgs','AT_ERRORS_QUESTION_EMPTY','Your question cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERRORS_TILE_UNAVAILABLE','The TILE server is unavailable.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERRORS_TRACKING_NOT_DELETED','Course tracking data could not be deleted. Possibly reasons: there is no tracking data for this course, or you do not have permission.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ACCESS_DENIED','Access Denied',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ACCESS_INSTRUCTOR','You must be registered as an instructor, and be logged in, to send a message to the Administrator.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ADMIN_INFO_NOT_FOUND','Administrator information cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ALREADY_ENROLED','You have already made a request to enroll in this course and you have not yet been approved by the instructor. You will be notifed when your request has been approved.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ALREADY_OWNED','You own this course, and cannot enrol.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ALREADY_SUB','You are already subscribed to this thread.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ANN_BOTH_EMPTY','The announcement title and body cannot both be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ANN_ID_ZERO','Announcement ID cannot be zero/missing.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ANN_NOT_FOUND','Announcement cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_BAD_DATE','That date is not valid.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_BAD_FILE_TYPE','Unsupported file type. Plain Text or HTML files only.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CACHE_DIR_BAD','Cache dir cannot be created. Cache disabled. See the configuration options to either disable or fix the problem.',NOW(),'global');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CANNOT_CREATE_DIR','Cannot create content directory.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CANNOT_OPEN_DIR','Unable to open content directory. You may try to <a href=\"tools/file_manager.php?create=1\">create it now</a>.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CANNOT_OVERWRITE_FILE','Cannot override file.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CANNOT_RENAME','File or directory cannot be renamed. Either a file or directory with that name already exists, the original file or directory does not exist, or the file or directory name has not changed.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CAT_DELETE_FAILED','Delete category failed.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CAT_HAS_SUBS','You must move or delete the sub categories first.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CAT_NOT_INSERTED','Category was <strong>not</strong> inserted.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CAT_NO_NAME','You must provide a category name',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CAT_UPDATE_FAILED','Update uncategorized failed.',NOW(),'admin coruse categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CHAT_TRAN_REJECTED','Transcript filename rejected. Please ensure that it is  alphanumeric and contains no spaces.',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CHOOSE_ONE_SECTION','You must select at least one section to print by choosing the corresponding checkbox.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CHOOSE_YESNO','Please choose either yes or no to whether you want to enter form data into a MySQL database table.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CPREFS_NOT_FOUND','No Preference settings were found for this course',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CREATE_NOPERM','You do not have permission to create courses.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CSS_ONLY','Unsupported file type. Style sheet files only (i.e. stylesheet.css).',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_CSV_FAILED','Unable to create %s CSV file.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DB_NOT_ACCESSED','Could not access MySQL database with information provided.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DB_NOT_CONNECTED','Could not establish connection to MySQL database with the information provided.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DB_NOT_UPDATED','Information could not be added to the database.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DEFINITION_EMPTY','The definition cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DESC_REQUIRED','You must provide a course description, before your instructor request can be processed.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DIR_NOT_DELETED','Cannot open directory to be deleted.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DIR_NOT_EMPTY','Cannot delete folder because it is not empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DIR_NOT_OPENED','Cannot open directory.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DIR_NO_PERMISSION','Cannot delete folder. You may not have premission, or it may not be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_DOB_INVALID','Date of birth has invalid format.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_EMAIL_EXISTS','An account with that email address already exists. Please use the <a href=\"password_reminder.php\">password reminder</a> feature to retrieve your password if it has been forgotten.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_EMAIL_INVALID','Email address was invalid.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_EMAIL_MISSING','You must enter an email address.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_EMAIL_NOT_FOUND','No account found with that email address.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_END_DATE_INVALID','That end date is not valid.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_EXPORTDIR_FAILED','Unable to create export directory.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FIELD_SIZE_EMPTY','[Field No: %s] Field size must be provided for a field of type \"Drop Down Select\".',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FIELD_SIZE_EMPTY_MULTI','[Field No: %s] Field size must be provided for a field of type \"Multiple Drop Down Select\".',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FIELD_TITLE_EMPTY','[Field No: %1$s] The \"Title\" for field no. %2$s was left blank.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FIELD_TYPE_EMPTY','[Field No: %s] Field type must not be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FILE_ILLEGAL','%s files are not allowed.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FILE_MAX_SIZE','The file exceeded the maximum allowable size limit of %s.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FILE_NOT_SAVED','The file cannot be saved.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FILE_NOT_SELECTED','You did not select a file to upload.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FILE_TOO_BIG','The file size exceeds the limit %s',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FOLDER_NOT_CREATED','The folder could not be created.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FORUM_NOT_FOUND','Forum can not be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_FORUM_TITLE_EMPTY','The forum title cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_GENERAL','This is a search and %s ATutor error.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_GLOS_ID_MISSING','Glossary term ID cannot be zero/missing.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_ID_ZERO','Content ID was zero, or was missing.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_IMPORTDIR_FAILED','Unable to create import directory',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_IMPORTDIR_NOTVALID','The file does not appear to be a valid course backup.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_IMPORTFILE_EMPTY','The import file must not be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_INCORRECT_FILE_FORMAT','Incorrect file format on line %s.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_INST_INFO_NOT_FOUND','Instructor information cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_INVALID_LOGIN','Invalid login/password combination.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_CHARSET_MISSING','You must enter a character set for this language.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_CODE_MISSING','You must enter the language code.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_ENAME_MISSING','You must enter the language name in English.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_IMPORT_FAILED','Language import failed.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_MISSING','You must choose a file to import.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_NNAME_MISSING','You must enter the language name in its native language.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LANG_REGEX_MISSING','You must enter the regular expression for this language.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LINK_CAT_NOT_EMPTY','Link category cannot be deleted because it contains sub-categories.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LIST_IMPORT_FAILED','Something went wrong with the course list import. Use a CSV file of the format (\"firstname\", \"lastname\", \"email\"), with one person per row.',NOW(),'course list import');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LOGIN_CHARS','Your user name must only contain letters, numbers, or underscores (_\'s).',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LOGIN_ENROL','You must be logged in to enroll in a course.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LOGIN_EXISTS','That login already exists, please choose another.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LOGIN_NAME_MISSING','You must enter a login name.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_LOGIN_TO_POST','You must be logged in to post.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_MAX_ATTEMPTS','The test cannot be taken.  It is not available at this time, or you have reached the maximum number of attempts for this test.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_MAX_STORAGE_EXCEEDED','Adding this file exceeds the maximum course storage limit.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_MSG_BODY_EMPTY','Your message body cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_MSG_SUBJECT_EMPTY','Your message subject cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_MSG_TO_INSTRUCTOR','You must be a registered ATutor user, and be logged in, to send the instructor a message.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NODELETE_USER','Cannot delete this user because they own courses. Delete the courses first.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NOT_OWNER','You do not own this course or it does not exist.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NOT_RELEASED','This content has not yet been released. %s',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_CONTENT_SPACE','Not enough space to import content directory. %s KB over the limit.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_COURSE_CONTENT','There is no content associated with this course.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_DB_CONNECT','Unable to connect to DB.<br />Possible causes: Incorrect user name and password; incorrect database name; or too many DB connections.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_IMSMANIFEST','IMS manifest file is missing. This does not appear to be a valid IMS content package.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_IMS_BACKUP','This file appears to be a <a href=\"tools/backup/\">course backup</a> rather than a content package.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_LANGUAGE','Selected language is not supported.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_QUESTIONS','No questions were found for this test.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_RECIPIENT','You must choose a recipient.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_SPACE_LEFT','There is no more space in this course to extract this archive.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_STUDENTS','There are no students enrolled in this course.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_SUCH_COURSE','No such course ID found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_TITLE','The title cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_NO_USER_PREFS','Could not fetch user preferences',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_OPTION_MISSING','[Field No. %1$s, Option No. %2$s] No option provided.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_PAGE_NOT_FOUND','Content page cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_PASSWORD_MISMATCH','Passwords did not match.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_PASSWORD_MISSING','You must supply a password.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_POLL_NOT_FOUND','Poll not found.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_POLL_QUESTION_EMPTY','Question cannot be empty.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_POST_ID_ZERO','Post ID cannot be zero/missing.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_POST_NOT_FOUND','Post cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_PREFS_NO_ACCESS','Either you are not logged in as the owner of this course, or you do not have permission to set preferences for this course',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_QUESTION_NOT_FOUND','Question not found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_REMOVE_COURSE','An unknown error while removing the course.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_RESULT_NOT_FOUND','Result not found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_SEARCH_TERM_REQUIRED','You must specify at least one search term.',NOW(),'search form');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_SEND_ENROL','You can only send a message to other members after you enroll in a course.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_SEND_MEMBERS','You can only send a message to others who are enrolled in the same courses as you. Your intended recipient may be viewing the course, but not enrolled.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_SIZE_TEXTAREA_BOTH','[Field No: %1] Field size 1 and Field size 2 are both required for field of type \"Text Area\".',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_START_DATE_INVALID','That start date is not valid.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_STUD_INFO_NOT_FOUND','Student information cannot be found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_SUPPLY_TITLE','You must supply a course name.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TABLE_NOT_CREATED','Could not create MySQL database table.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TERM_EMPTY','The term cannot be empty.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TERM_EXISTS','The term <strong>%s</strong> already exists.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TERM_NOT_FOUND','Glossary term cannot be found',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_COLNAME_MISSING','Column %1$s for field \"%2$s\" was not entered.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_COL_NOSPACE','<li>Column %1$s for field \"%2$s\" cannot contain spaces.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_EMAIL_INVALID','You did not provide a valid email address.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_EMAIL_MISSING','You did not provide an email address to send the form data to.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_HOSTUSER_MISSING','You did not enter hostname and/or username and/or database name.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_NOT_FOUND','Test not found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_TABLENAME_MISSING','You did not enter the name of the table to be created.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TEST_THANKYOU','You did not provide a thank-you page URL to redirect the user to after they have filled the form.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_THEME_NOT_FOUND','Theme not found.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TITLE_EMPTY','Course Title cannot be empty.',NOW(),'course properties');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_TRAN_NOT_FOUND','Transcript not found.',NOW(),'achat delete transcript');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_UNKNOWN','An undetermined error has occurred.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_UNSUPPORTED_FILE','Unsupported file type. Plain Text or HTML files only.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_ERROR_VALUE_MISSING','[Field No. %1$s, Option No. %2$s] No value provided.',NOW(),'error msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_ACCOUNT_PENDING','Your Instructor account request is awaiting approval from the system administrator. You will be notified by email when your request has been approved. Return here after your Instructor account has been activated, to begin creating courses.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_APPLY_PREFS','<a href=\"%1$s?save=2\">Save and apply these preferences</a> or <a href=\"%1$s?save=3\">Cancel Changes</a>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_APPLY_PREFS2','Save and apply these preferences to <a href=\"%1$s?save=2\">Every Course</a> or <a href=\"%1$s?save=3\">Cancel Changes</a>. If you want to save these preferences to this course only, you must first <a href=\"enroll.php?course=%2$s\">enroll</a> into this course.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_APPROVAL_PENDING','Your request has been made. You will be notifed when your request has been approved.<br /><br />Return to your <a href=\"users/index.php\">Control Centre</a>.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_ARCHIVE_EXTRACTED','Archive has been extracted successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_AUTO_DISABLED','Auto-Login has been disabled',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_AUTO_ENABLED','Auto-Login has been enabled. Next time you enter ATutor using this computer, you will bypass the login screen. ',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_BANNER_UPDATED','Course banner was successfully updated.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CANCELLED','Successfully cancelled without any changes.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CAT_ADDED','Category was successfully added.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CAT_DELETED','Category was successfully deleted.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CAT_UPDATE_SUCCESSFUL','Category was successfully updated.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CLOSED','Successfully closed',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CONTENT_ADDED','Content was successfully created',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CONTENT_DELETED','Content was successfully deleted',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CONTENT_DIR_CREATED','Content directory created successfully.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CONTENT_UPDATED','Content was successfully updated',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COPYRIGHT_UPDATED','Copyright successfully updated.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_CREATED','You have successfully created your course! See <a href=\"help/about_help.php\">About ATutor Help</a> for more about sources of information on using ATutor.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_DEFAULT_CSIZE','The \'Course Quota\' was set to \'Default\' as the entered course size was either empty or negative.',NOW(),'course properties: course size was set to default');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_DEFAULT_FSIZE','The \'Max File Size\' was set to \'Default\' as the entered file size was either empty or negative.',NOW(),'course properites: file size was set to default');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_DELETED','Course has been successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_PREFS_SAVED','Course preferences were saved',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_PROPERTIES','Course properties were successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_REMOVED','Course was removed successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_COURSE_UPDATED','The course properties were successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CSS_PREVIEW','To view the effects of changes to your style sheet, set \"Override selections ...\" to <strong><em>Yes</em></strong> in the \"Themes\" <a href=\"tools/preferences.php\">preference</a> settings.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_CSS_UPDATED','Style sheet was successfully updated',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_DEFAULT_CSS_LOADED','Default style sheet was successfully loaded. Press \"Save Course Styles\" to apply the changes.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_DEFAULT_WRAP_TEMPLATE','The default wrap-around template was successfully pasted into the textareas. Make your modifications, then press \"<strong><em>Save Course Header</em></strong>\" to apply the template.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_DIR_DELETED','Folder was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_ENROLMENT_UPDATED','Enrollment was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_EXPORT_CANCELLED','Export cancelled successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_DELETED','File was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_EXISTS','The file <strong>%1$s</strong> already exists. The newly uploaded file was saved as <strong>%2$s</strong>. <a href=\"tools/file_manager.php?overwrite=%2$s%4$spathext=%3$s\">Overwrite</a> the old existing file with the newer one.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_OVERWRITE','File overwrite successful.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_PASTED','The file was successfully pasted into the textarea below. <strong><em>Save to apply changes</em></strong>, or Cancel to return to the previously saved content.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_UPLOADED','File was successfully uploaded.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FILE_UPLOADED_ZIP','File was successfully uploaded. You may now <a href=\"tools/zip.php?pathext=%1$s%3$sframe=%2$s\">extract</a> the file.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FORUM_ADDED','Forum has been created successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FORUM_DELETED','Forum was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_FORUM_UPDATED','Forum was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_GLOSSARY_DELETE2','Glossary item successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_GLOS_UPDATED','Glossary was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_IMPORT_CANCELLED','Import cancelled successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_IMPORT_LANG_SUCCESS','New language was successfully imported. You may view and modify the new language by choosing it from the selection menu below.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_IMPORT_SUCCESS','Course content was successfully imported.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_LANG_DELETED','Language was successfully removed.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_LINK_CAT_DELETED','Link category deleted successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_LINK_CAT_EDITED','Link category edited successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_LOGOUT','You have successfully been logged out.',NOW(),'after logging out');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_MESSAGE_DELETED','Message was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_MSG_DELETED','Message was deleted successfully ',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_MSG_SENT','Message has been sent successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_NEWS_ADDED','Announcement was successfully created',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_NEWS_DELETED','Announcement was successfully deleted',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_NEWS_UPDATED','Announcement was successfully updated',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_NOW_ENROLLED','You are now enrolled in the %s course. You may enter the course at any time. To un-enroll, select \"Remove\" next to the course listing in the Enrolled Courses table in My Courses.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_POLL_ADDED','Poll successfully added.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_POLL_DELETED','Poll has been deleted successfully.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_POLL_UPDATED','Poll successfully updated.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_POST_EDITED','Message was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PREFS_CHANGED','Your preferences have been changed for the current session. To have these changes take affect next time you login you must save them.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PREFS_LOGIN','You cannot save these preferences because you are not logged in.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PREFS_RESTORED','Your preferences have been restored.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PREFS_SAVED1','Preferences have been saved for this course.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PREFS_SAVED2','Your preferences have been saved successfully.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PRIVS_CHANGED','Role &amp; Privileges changed successfully.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_PROFILE_UPDATED','Your Profile was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_QUESTION_ADDED','Question was successfully added.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_QUESTION_DELETED','Question was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_QUESTION_UPDATED','Question was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_REG_THANKS','Thank you for registering, please <a href=\"login.php\">login</a>.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_RENAMED','File or directory has been successfully renamed.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_RESULTS_UPDATED','Result was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_RESULT_DELETED','Result was successfully deleted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_STICKY_UPDATED','Thread stickyness was updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_STYLES_UPDATED','Course styles were updated',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TABLE_CREATED','The following table has been created successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TEST_ADDED','Your test/survey was created successfully.Use the \"<strong><em>Questions</em></strong>\" link in the table below to add questions to this test.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TEST_DELETED','The test/survey has been successfully deleted.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TEST_NODATA','Test/survey has no data.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TEST_SAVED','Your test/survey results have been saved and appear in the <strong>Completed Tests &amp; Surveys</strong> section below.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TEST_UPDATED','Test was successfully updated.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_DELETED','Thread has been deleted successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_LOCKED','Thread has been successfully <strong><em>locked</em></strong>.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_REPLY','Reply was successfully posted.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_STARTED','Thread was successfully started.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_SUBCRIBED','You are now subscribed to recieve messages from this thread by email.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_UNLOCKED','Thread has been successfully <strong><em>unlocked</em></strong>.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_THREAD_UNSUBCRIBED','You have successfully unsubcribed from this thread.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TRACKING_DELETED','Course tracking data was successfully deleted for this course.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_TRAN_DELETED','Transcript was successfully deleted',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_msgs','AT_FEEDBACK_USER_DELETED','User deleted successfully.',NOW(),'feedback msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_ANNOUNCEMENT','You are currently on the Course Announcements page. Click on <strong><em><a href=\"SITE_URL/editor/add_news.php\">Add Announcement</a></em></strong> below to add content to this page. This page is the course Home Page, through which students enter your course. Notice the links to it in the Breadcrumbs above and at the top of the <a href=\"SITE_URL/?enable=PREF_MENU\">Global Menu</a>, among other places throughout ATutor.<br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_ANNOUNCEMENT2','You are currently on the Course Announcements page. Click on <strong><em><a href=\"SITE_URL/editor/add_news.php\">Add Announcement</a></em></strong> below to add content to this page. This page is the course Home Page, through which students enter your course. Notice the links to it in the Breadcrumbs above and at the top of the <a href=\"SITE_URL/?disable=PREF_MENU\">Global Menu</a>.<br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_CODES','The Discussion and Link codes will insert icons that are linked to the Forums and the Links Database. When inserting images using the image code, be sure to include a short text description of the image in the second half of the opening code labelled \"alt text\". Clicking on an icon or code link inserts the code at the end of the content of this page.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_CODES1','Use the codes listed below to apply basic formatting to you content, or to insert links or images. Use HTML to create more detailed formatting.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_FORUM_MINI','Provide a descriptive title that signifies the main topic of discussion. Describe the topics, and the types of discussion that should take place in this forum.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_MC_QUESTION','Create two or more choices for the question, and select one of those choices to be the correct answer. Create feedback to display with the results presented to test takers (i.e. the correct answer, or an explanation).',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_OPEN_QUESTION','Create different types of open ended questions by choosing from the Answer Sizes below. These questions are presented with either a text field, a small textarea, or a large text area.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_QUESTIONS','Click on the <strong><em>Questions</em></strong> link for the newly listed test, to add questions to it. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_QUESTIONS2','Choose from the <strong><em>Add Questions</em></strong> links below, to add a new question to this test. Use the <strong><em>Edit</em></strong> link in the listing created for a question, to make changes.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_RESOURCE','URL, Title, Description, and Your Name, are required fields.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_RESOURCE1','Use appropriate keywords in your description to aid resource searches. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_RESOURCE_MINI','Keep your description brief. Mention what content could be found on the site and what it is about. Do not praise the site by using words like \"best\" or \"greatest\" in your description. Try to use appropriate keywords to aid searching.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_TEST','Make sure the title is concise and descriptive (e.g. \"Chapter 1 Quiz\").  \r\n\r\nFor surveys, set the Marking setting to \"Do not mark\", and restrict the number of a times a student can submit results.   You may also want to treat the submissions as anonymous.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_TF_QUESTION','Supply a statement that can be answered with either the word \"true\", or the word \"false\". Include an explanation or a reference as feedback, to display with results persented to test takers.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ADD_TOP_PAGE','You may add main content pages to your course by clicking on <strong><em><a href=\"SITE_URL/editor/edit_content.php\">Add Content</a></em></strong>. This will add an entry to the Menu. Also notice that \"Add Content\" also appears in the menu, so you may add main pages from there as well.<br />',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ANNOUNCEMENT','Announcements will appear on the course Home Page. Text or HTML is allowed. At least one of the two fields is required.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_BANNER_TEXT','Choosing Default will display the name of the course in the banner area.  You may choose Custom to enter any html, including text and images, to display instead.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_BODY','Text content is presented as it is typed into the Body textarea. HTML can be used to add formatting to your content. Type in HTML formatted content, or use an HTML editor to create your content, then use the <strong>Paste from File</strong> field above to upload the file into the Body textarea.  Use the <strong>Save Changes</strong> button after importing to save the page.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_BROWSER_PRINT_BUTTON','Use your browser\'s print button to print this compiled page.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CONTENT_BACKWARDS','If you intend re-using content created in this version of ATutor, in ATutor version1.2 or earlier, use the CONTENT_DIR variable to define the path to your content files. For example, the path to \"myimage.gif\", located in the \"images directory, would have its path defined as \"CONTENT_DIR/images/myimage.gif\".',NOW(),'content editor');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CONTENT_PATH','When linking to files in your content directory, the path to those files is relative to your content directory. For example, if you have a directory named \"images\", and it contains a graphic called \"myimage.gif\", the path to that graphic would be \"images/myimage.gif\".',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CONTROL_CENTER1','Select <strong><em>Browse Courses</em></strong> to view a list of courses on this ATutor server. Access a course and enroll to add that course to your list of <strong><em>Enrolled Courses</em></strong>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CONTROL_CENTER2','Select <strong><em>Create a New Course</em></strong> to set up the initial framework for your course. You will be placed into your course framework when you submit the intial setup, after which you may begin adding content. Your new course, and its properties, can be managed on the <strong><em>Tools</em></strong> page, under the heading <strong><em>Instructor Tools</strong></em>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CONTROL_PROFILE','Modify your Account Information by selecting the <strong><em>Edit Profile</em></strong> link in the menu to the left.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_COURSE_EMAIL','Send a plain text email message to all students in this course. Introduce weekly lessons, announce tests or assignments, warn students about an approaching deadline, or send any message that should be read by the entire class.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_COURSE_PREF','This course has a recommended set of <a href=\"../../users/preferences.php#preset\">preferences</a>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_COURSE_PREF2','This course has a recommended preferences preset. Use the Apply Preset button to use those preferences.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_COURSE_QUOTA','You may enter the course size limit in Megabytes.  This may be a fraction (0.5).  1 Megabyte = %s Kilobytes = %s Bytes',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CREATE_FORUMS','Click on \"<strong><em><a href=\"editor/add_forum.php\">New Forum</a></em></strong>\" to add a new forum to your course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CREATE_HEADER','To create a custom header for your course, enter HTML formatted content into the textarea below. Use your <a href=\"tools/file_manager.php\">File Manager</a> to upload images (etc.) linked from your header, into your course content directory. See <a href=\"http://atutor.ca/howto.php\">ATutor HowTo</a> for more about creating a custom course header.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CREATE_LINKS','Create categories in which to sort links by entering topic names in to the \"<strong><em>New Category</em></strong>\" field below.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CREATE_LINKS1','To add a new link move into the category where it should reside, then click \"<strong><em>Suggest a New Link</em></strong>\".',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_CUSTOM_HEADER','Insert HTML formatted content to create a custom header for this course. Or, click on \"Load Default Wrap-around Template\", then modify the template with your own content.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_DEMO_HELP','This is a demo Context Sensitive Help. Hover over it with a mouse pointer, or click on it, to display the accompanying help.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_DEMO_HELP2','This is a demo Help Box. When the Help Box preference is disabled, the Help Icon becomes clickable, so Help Boxes can be opened and close.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_DISABLE_EDITOR','Use the <img src=\"SITE_URL/images/pen2.gif\" alt=\"Disable Editor Icon\" /><strong><em><a href=\"?disable=PREF_EDIT\">Disable Editor</a></em></strong> link in the side menu to hide the editing tools.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_DISPLAY_OPTIONS','Incremental <strong><em>topic numbers</em></strong> ( eg. 1.2.6) appear before menu listings and page headings. <strong><em>Breadcrumbs</em></strong> are the series of links at the top of the content area, allowing you to move up through content levels. <strong><em>Heading navigation </em></strong>appears at the top of the content area, also allowing you to move up through content levels. <strong><em>ATutor help</em></strong> appears as boxes containing ATutor usage information. Hide them once you know your way around ATutor.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_EDITOR','The Disable/Enable Editor link will hide or show the editing tools.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_EDIT_STYLES','Create a custom look and feel for your course. Load the ATutor Default Stylesheet, make modification to it, then save to see the effects. The course style sheet is used when visitors are not using their own custom preference settings, or when \"Override selections ...\" is set to \"yes\" in the theme preferences. With this setting each course appears with its own unique appearance.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_EDIT_STYLES_MINI','Upload an existing style sheet from your local hard drive, to be pasted into the textarea below. You may prefer to begin with the ATutor default stylesheet, then edit it\'s attributes to create your own custom styles.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_EMBED_GLOSSARY','To embed a definition into your content use [?] to designate the start of the term and a [/?] to designate the end of the term.<br />Example: <code>[?]ATutor[/?]</code>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ENABLE_EDITOR','Use the <img src=\"SITE_URL/images/pen.gif\" alt=\"Enable Editor Icon\" /><strong><em><a href=\"%senable=PREF_EDIT\">Enable Editor</a></em></strong> link in the side menu to view the editing tools available for this area.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ENROLMENT','Select a user\'s Login name to view his or her registration information.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_ENROLMENT2','Check \"Remove\" and then use the \"Submit\" button to take a member off the enrollment list.  If this is a Private course, select Approve, or Disapprove, to change a user\'s enrollment status.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILEMANAGER','Upload files here to link to your content pages. Click on \"Open File Manager frame\", to have it open while editing your content.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILEMANAGER1','Right click on a file then select \"copy link location\" (or what ever your browser calls this function), to copy the file\'s path, then paste that path into your content.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILEMANAGER2','You might first create a number of <strong><em>folders</em></strong>, in which to sort your course files. You might create different directories for images, sound files, assignment downloads, or perhaps directories for each lesson.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILEMANAGER3','Assuming you know a little HTML, you can <strong><em>link to files</em></strong> in your course directory using a path something like href=\"assignments/week1intro.doc\".<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILEMANAGER4','To <strong><em>find the path</em></strong> to a course file, find the file in the File Manager then notice the \"Path to Current Directory\" information. The path after \"Home/\" is the path from the content to the File Manager content.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILE_EXPORTABLE','Using <code>CONTENT_DIR</code> will make it possible to export and import your course material easily without having to change the path to the files. If you do not intend to move your course, you can right click on a filename and copy the link location, then paste that path into your HTML',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FILE_LINKING','To link to course files use <code>CONTENT_DIR</code> as the path to the content home directory. For example, if you upload an image called MyImage.gif then you would link to it in your HTML using <code>CONTENT_DIR</code>/MyImage.gif as the path to the image. <code>CONTENT_DIR</code> will automatically be replaced with the correct path to that file when the page is viewed. If you upload an image to a folder called MyFolder then upload the same image, then the path to use will become <code>CONTENT_DIR</code>/MyFolder/MyImage.gif <br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FORMATTING','Plain text content will display as it appears in the Body textarea. Use HTML, or the codes listed below, to add formatting, links, graphics, etc. to your content.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FORUM_LOCK','Click on the \"lock\" icon [<img src=\"images/lock.gif\" height=\"18\" width=\"16\" alt=\"lock icon\"/>] to restrict posts to a thread, or to hide a thread from reading and posting.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_FORUM_STICKY','Click on the \"sticky\" icon [<img src=\"images/forum/sticky.gif\" height=\"18\" width=\"16\" alt=\"sticky icon\"/>] to fix a message thread to the top of the thread list. Multiple sticky threads are ordered by the date of the last post to the thread.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_GLOBAL_MENU','The Global Menu is a collapsible menu that can be used to display the entire course. Use <strong><em>Alt-7</em></strong> to open or close this menu.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_GLOSSARY_MENU','When terms on the current page are listed in the glossary, those listings will appear in this menu. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_GLOSSARY_MINI','Words or phrases may be added to the glossary. If related terms exist, associate them to this term (phrase) using the selection menu below. Glossary terms are displayed in a mouseover box like this one, or on a separate page if a user clicks the glossary item e.g. [?]',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_HIDE_HELP','You may <strong><em>Hide Help</em></strong> by disabling it in your Display Options <a href=\"tools/preferences.php\">preference settings</a>.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_IMPORT_EXPORT','Export course content to create backups, to create a copy of your course to import as a new course session, or to create a copy to import on to another ATutor server.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_IMPORT_EXPORT1','Import an entire course into an empty course framework (created with Create a New Course), or append the content of a backup file to a course where content already exists. Depending on the size of the file you are uploading, and the speed at which you are connected to the Internet, importing may take a while.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_INSERT','Locate this page within other pages of the course. Move the page around within this section, or move it to another section.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_LINK_FILES','Click on the link below to open the File Manager Frame. To create a link to a file displayed in the File Manager Frame, you might right click on the filename, then chose from the options to copy the link or favorite\'s location. After that move into the Body area and paste the location into your content (e.g. right-click>>paste, ctrl-v).',NOW(),'add/edit content');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_LOCAL_MENU','The Local Menu is a collapsible menu that displays the topics in the current content section. Links at the top and bottom of this menu lead to the previous and next major topics in the course. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_MAIN_MENU','Hide the menus to conserve space. Using your preference settings, locate the menu on the left or right. Toggle this menu opened or closed with your keyboard by pressing Alt-6.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_MARK_RESULTS','Test are marked when an instructor views a submitted test and re-submits it, after which results become available to students. Multiple choice and true/false questions are marked automatically. Open ended questions require the instructor to enter a mark manually.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_MENU_OPTIONS','Configure the display of ATutor Menus. Choose those you use, and eliminate others. Put the most used menu at the top. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_NETSCAPE4','<strong style=\"color:#FF0000\"><em>IMPORTANT</em></strong>: You appear to be using an older version of <strong><em>Mozilla/Netscape</em></strong>. While ATutor will function adequately with this browser, a variety of features will not be available to you. We strongly recommend upgrading to a more current browser.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_NOT_RELEASED','This page will become available to students on the selected date.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_NO_HELP','There is no help available at this time.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PASTE_FILE','Pasting from a file will insert the contents of the file into the Body field below. Create your content in an HTML editor, then import the page here.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PASTE_FILE1','You can safely paste content into the Body area without altering the existing content. Saving will erase any previous content',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_POLL_MENU','To vote in the poll, select your choice from the list and use the Vote button.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_POSITION_OPTIONS','You might choose to locate the menus on the left if you are left handed. Sequence Links are the arrows that allow you to move through content pages in order. The Table of Contents appears on content pages as a collapsible list of sub pages associated with the current topic.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PREFERENCES','You might choose from the Preset preferences below, then adjust those settings in the <strong><em>Personal Preferences</em></strong> table.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PREFERENCES1','The Preset <strong><em>Accessibility</em></strong> settings will strip away all non-essential navigation elements, optimizing ATutor for use with various assistive technologies.<br /><br />',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PREFERENCES2','Preferences are first set for the session currently running. <strong><em>You must save the current settings</em></strong> if you want them to display on future visits. In the feedback box that appears after clicking \"Set Preferences\", choose <em><strong>Save and apply these preferences</strong></em>.<br /><br />',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PRESET','Select from the Preset Preferences to apply those settings immediately. To modify the preset preferences after applying them, adjust the settings that were updated in the personal preferences table below. See the feedback after applying a preset for more options.',NOW(),'preferences mini');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_PREVEIW_QUESTIONS','Return to the <a href=\"tools/tests/\">Test Manager</a> opening screen and click on <strong><em>Preview</em></strong> next to the listing for the test <strong><em> %s</em></strong>.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_RELATED','Select other topics in the course related to this one. Topics appear in the \"Related Topics\" menu when this page is viewed.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_RELATED_MENU','The Related Topics Menu displays other topics in this course that are related to the one currently being viewed. ',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_SEARCH','Enter keywords or terms separated by spaces.',NOW(),'search');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_SEARCH_MENU','Search this course by entering keywords separated by spaces. Add additional keywords to narrow your search.',NOW(),'search box in menu');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_TEXTICON_OPTIONS','You might choose to turn off icons if you are using a screen reader. If you prefer to view a graphic display, turn icons on. To reduce clutter, display icons without a text label.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_THEME_OPTIONS','Choose a theme from the available list to change the general look-and-feel.  Pick one that is easiest for you to view, Set Preferences and then save the new settings.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_TRACKING','Select from the menu below, the student who\'s navigation tendencies and click path you wish to view.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_TRACKING1','Select a page from the menu below, to view its statistics.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_HELP_USERS_MENU','The Users Online Menu is a list of people currently logged into this course. Click on a user\'s login name to send a private message to that person\'s inbox. You (and the recipient) must be enrolled in this course to send messages.',NOW(),'help msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_ACCOUNT_APPROVED','You have successfully upgraded to an instructor account.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_ACCOUNT_PENDING','Your instructor account request has been made. You will be notifed by email when your request has been approved.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_APPROVAL_PENDING','Your request has been made. You will be notifed when your request has been approved.<br /><br />Return to <a href=\"users/index.php\">My Courses</a>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_CHOOSE_NUMBERS','All the fields are required. Tip: numbers make the best choices for <code>value</code> fields.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_CSS_DEPRECATED','The ability to use a custom course stylesheet has been deprecated and has been removed.  You may change the appearance of the course banner in <a href=\"tools/banner.php\">Course Banner</a>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_CSS_DEPRECATED_DL','You may <a href=\"%s\">download</a> custom course stylesheet.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_DECISION_NOT_REVERSED','Decisions could not be reversed.',NOW(),'AChecker - can\'t reverse decision');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_DECISION_NOT_SAVED','Decisions could not be saved.',NOW(),'AChecker - can\'t save decision');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_DECISION_REVERSED','Decision reversed successfully.',NOW(),'AChecker - reverse decision');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_GLOSSARY_REMAINS','Note that removing a linked glossary term from your content will <strong>not</strong> delete the term from the glossary.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_HEADFOOT_DEPRECATED','The ability to use a custom course header and footer has been deprecated and has been removed.  Customize the look of your course banner area by changing its attributes below.<br /><br />This feature may not be supported by all themes.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_HEADFOOT_DEPRECATED_DL_F','You may <a href=\"%s\">download</a>  your footer code.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_HEADFOOT_DEPRECATED_DL_H','You may <a href=\"%s\">download</a>  your header code.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_INBOX_EMPTY','There are no messages in your inbox.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_INVALID_URL','Localhost is not a valid URL',NOW(),'Used when AChecker reading URL');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_INVALID_USER','You must <a href=\"login.php?course=%s\">login</a> to use this section.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_MSG_SEND_LOGIN','You must be logged in to send messages.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NOT_ENROLLED','You need to be enrolled in this course to access this area.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NOT_RELEASED','This content has not yet been released. %s',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_CATEGORIES','No Categories Found.',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_CONTENT','This course has no content yet.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_ENROLLMENTS','No students are enrolled in this course.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_MORE_FIELDS','There are no additional options for the fields you chose. Use the \"next\" button to continue.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_PAGE_CONTENT','There is no content on this page.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_PERMISSION','You do not have permission to access this page.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_POSTS_FOUND','There are no posts in this forum.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_SEARCH_RESULTS','No search results.',NOW(),'search page');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_NO_TERMS','No glossary terms were found.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_OVER_QUOTA','You have reached or passed your maximum quota for this course. You will have to delete some files before you will be able to upload again.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_PRIVATE_ENROL','The course you are trying to access is <strong>private</strong>. Enrollment in this course requires instructor approval.<br />',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_REQUEST_ACCOUNT','You do not yet have permission to create courses. If you would like your account upgraded to Instructor status, enter the <strong>required description</strong> of the course you wish to create, then use the \"Request Instructor Account\" button to submit your request for approval.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_SAVE_CONTENT','Content must be saved before it can be evaluated.',NOW(),'AChecker requirement in ATutor content');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_SERVICE_UNAVAILABLE','Service currently unavailable.',NOW(),'Used for AChecker');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_TRACKING_NO_INST','You have chosen your own ID number. Tracking information is not recorded for course instructors. Choose another user.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_TRACKING_NO_INST1','Tracking information is not recorded for course instructors. See the <a href=\"tools/course_tracker.php\">Course Tracker</a> for a record of course activity.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_TRACKING_OFFIN','Tracking is not enabled for this course. Contact your system administrator to have it turned on.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_INFOS_TRACKING_OFFST','Tracking is not enabled for this course.',NOW(),'info msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_AUTO_LOGIN','Be aware that others using this computer will be able to access your courses, and will appear to be logged in as you. Auto-Login should <strong>not</strong> be enabled when using a public work station.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_CHAT_TRAN_EXISTS','A transcript with the name %s already exits. Either delete the original transcript, then resubmit, or rename your new transcript.',NOW(),'achat instructor transcript tool');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_CONFIRM_DIR_DELETE','Are you sure you want to delete folder <strong>%s</strong> and all its contents?',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_CONFIRM_FILE_DELETE','Are you sure you want to delete file <strong>%s</strong>?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_CATEGORY','Are you sure you want to delete this category with all its links?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_CAT_CATEGORY','Are you sure you want to delete category  <strong>%s</strong>?',NOW(),'admin coruse categories');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_CONTENT','Are you sure you want to delete this page?<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_FORUM','Are you sure you want to delete <b>%s</b>? All messages posted to this forum will be erased.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_LANG','Are you sure you want to delete the language ( <strong>%s </strong>)?',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_MESSAGE','Are you sure you want to delete this <strong>message</strong>. It can not be recovered once deleted.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_NEWS','Are you sure you want to delete %s?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_POLL','Are you sure you want to delete this poll \'%s\'?  It cannot be recovered once deleted.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_QUESTION','Are you sure you want to delete this question? It will be permanently erased.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_RESULTS','Are you sure you want to delete results for user <strong><em>%s</em></strong>?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_TEST','Are you sure you want to delete the test/survey <strong><em>%s</em></strong>? All the questions and all the results will be permanently erased.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_THREAD','Are you sure you want to delete this <strong>thread</strong>. It can not be recovered once deleted.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_TRACKING','Are you sure your want to delete the tracking data for this course? You might choose to <a href=\"%s?csv=1\">create a backup</a> before you empty the database.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_DELETE_USER','Are you sure you want to delete user <b>%s</b>?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_EXPERIMENTAL11','This tool is experimental. Expect there to be much room for improvement!',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_GLOSSARY_DELETE','Are you sure you want to delete this glossary item?<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_GLOSSARY_REMAINS','Embedded glossary definitions will not be deleted.<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_GLOSSARY_REMAINS2','Glossary items embedded in content pages will not be delete.<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_LANG_EXISTS','The language you are uploading is already installed on this system. Delete the existing language first by selecting the \"<strong>Remove</strong>\" link next to its listing below.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_LINK_WINDOWS','Links open in a new window.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_LOGIN_INSTRUCTOR','You will be logged in as the instructor for this course.  To return to <strong>%s Administration</strong>, you will need to log out as the instructor and then log in again as administrator.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_RAM_SIZE','Depending how much RAM your computer has, and the size of the course you wish to print, selecting the entire content of a large course may cause your computer to lock up.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_REMOVE_COURSE','Are you sure you want to delete <strong>%s</strong> from your Enrolled Courses?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SAVE_TEMPLATE','Your template is not yet saved. Saving it will erase any existing header. Use \"Cancel\" to revert to your previously saved header.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SAVE_YOUR_WORK','Save your work before opening or closing the File Manager.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SUB_CONTENT_DELETE','This content page has sub content. If you delete this page all its sub pages will be deleted as well.<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SURE_DELETE_COURSE1','Are you sure you want to <b>Delete</b> the course <strong><em>%s</em></strong>',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SURE_DELETE_COURSE2','Are you <b>really really</b> sure you want to <b>Delete</b> the course <strong><em>%s</em></strong>. Deleted courses can not be recovered.',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_SURE_DELETE_USER','Are you sure you want to delete user <b>%s</b>?<br />',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_msgs','AT_WARNING_THREAD_DELETE','Are you sure you want to delete this thread?',NOW(),'warning msg');
INSERT INTO `lang_base` VALUES ('_template','.welcome_translator','This is just a test message.\r\n\r\nWelcome to the ATutor translator site! To translate to your given language edit the text box and use \"Save ALT-S\" to save the changes.\r\n\r\nYou can then view the changes instantly on the ATutor development server.\r\n\r\nGood luck!\r\n- ATutor development team\r\n\r\nps. there is no need to translate this message.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','15_max_chars','15 characters maximum',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','20_max_chars','20 character maximum',NOW(),'login name registration screen');
INSERT INTO `lang_base` VALUES ('_template','404','Error: Missing Page',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','404_blurb','The page you are trying to access <i>%s</i> does not exist, or has been moved. Try using the <a href=\"tools/sitemap/\">SiteMap</a> to find it.',NOW(),'global');
INSERT INTO `lang_base` VALUES ('_template','about_atutor','About ATutor',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','about_atutor_help','About ATutor Help',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','about_atutor_help_text','Learn about various sources of ATutor help, and the help display options available.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','about_browse','\"Protected\" courses require an <a href=\"registration.php\">ATutor System Account</a> while \"Public\" courses do not. \"Private\" courses require an ATutor System Account, enrollment in the course, and approval from the course instructor.',NOW(),'top of Browse Course screen');
INSERT INTO `lang_base` VALUES ('_template','about_help','Read about this and other help features',NOW(),'link at bottom of help boxes');
INSERT INTO `lang_base` VALUES ('_template','about_private','Available only to users with an ATutor System Account, and Instructor approved enrollment. Login required. Enrollment is required.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','about_protected','Available only to users with an ATutor System Account. Login required. Enrollment is optional.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','about_public','Available to all users with or without an ATutor System Account. Login not required. Enrollment is optional.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','access','Access',NOW(),'create a new course');
INSERT INTO `lang_base` VALUES ('_template','accessibility','Accessibility',NOW(),'help page');
INSERT INTO `lang_base` VALUES ('_template','accessibility_features','Accessibility Features',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','accessibility_features_text','Using ATutor with assistive technology and other accessibility features.',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','accesskey','Accesskey',NOW(),'global (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','access_ascending','Order by Access Ascending',NOW(),'admin courses table');
INSERT INTO `lang_base` VALUES ('_template','access_credit','Accessibility report provided by <a title=\"ATRC Web Accessibility Checker (link opens in a new window)\" target=\"_new\" href=\"http://checker.atrc.utoronto.ca?lang=eng\">ATRC Web Accessibility Checker</a>.',NOW(),'include/html/editor_tabs/accessibility.inc.php');
INSERT INTO `lang_base` VALUES ('_template','access_descending','Order by Access Descending',NOW(),'admin courses table');
INSERT INTO `lang_base` VALUES ('_template','access_method','Access Method',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','access_stats','Access Method Statistics for',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','account_information','Account Information',NOW(),'control centre/registration');
INSERT INTO `lang_base` VALUES ('_template','account_login','Log into your ATutor Account',NOW(),'private enroll screen');
INSERT INTO `lang_base` VALUES ('_template','acollab','ACollab',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ac_access_groups','Access Groups',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ac_access_text','View and participate in your course group(s).',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ac_create','Create a New Group',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ac_create_text','Create a new group for this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','added','Added',NOW(),'global');
INSERT INTO `lang_base` VALUES ('_template','add_announcement','Add Announcement',NOW(),'course announcments/home page');
INSERT INTO `lang_base` VALUES ('_template','add_code','Add Code',NOW(),'Title for code tags in code picker');
INSERT INTO `lang_base` VALUES ('_template','add_content','Add Content',NOW(),'heading/submit button on Add Content screen');
INSERT INTO `lang_base` VALUES ('_template','add_forum','Add Forum',NOW(),'add forum screen');
INSERT INTO `lang_base` VALUES ('_template','add_glossary','Add a Glossary Term',NOW(),'glossary screen');
INSERT INTO `lang_base` VALUES ('_template','add_language','Add Language',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','add_likert_questions','Add Likert Questions',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','add_link_in','Add a link in',NOW(),'links database, suggest a new link screen');
INSERT INTO `lang_base` VALUES ('_template','add_lk_question','Add Likert Question',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','add_mc_question','Add Multiple Choice Question for: %s',NOW(),'test manager, add multiple choice  screen');
INSERT INTO `lang_base` VALUES ('_template','add_mc_questions','Add Multiple Choice Questions',NOW(),'test manager add questions');
INSERT INTO `lang_base` VALUES ('_template','add_new_link','Add New Link',NOW(),'Links database');
INSERT INTO `lang_base` VALUES ('_template','add_new_resource','Add a New Resource',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','add_open_question','Add Open Ended Question for %s',NOW(),'test manager add open question');
INSERT INTO `lang_base` VALUES ('_template','add_open_questions','Add Open Ended Questions',NOW(),'test manager add questions');
INSERT INTO `lang_base` VALUES ('_template','add_poll','Add Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','add_post','Add Post',NOW(),'forum post message screen');
INSERT INTO `lang_base` VALUES ('_template','add_question','Add Question',NOW(),'test manager add questions screen');
INSERT INTO `lang_base` VALUES ('_template','add_questions','Add Questions',NOW(),'test manager add questions screen');
INSERT INTO `lang_base` VALUES ('_template','add_term','Add Term',NOW(),'glossary');
INSERT INTO `lang_base` VALUES ('_template','add_test','Add Test/Survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','add_tf_question','Add True or False Question for %s',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','add_tf_questions','Add True or False Questions',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','add_top_page','Add Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','administration','Administration',NOW(),'admin home page');
INSERT INTO `lang_base` VALUES ('_template','after','After',NOW(),'add/edit content mover');
INSERT INTO `lang_base` VALUES ('_template','after_topic','After: %s',NOW(),'content editor');
INSERT INTO `lang_base` VALUES ('_template','age','Age',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','all','All',NOW(),'glossary');
INSERT INTO `lang_base` VALUES ('_template','all_available_courses','All available courses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','always_one','(should always be 1)',NOW(),'delete course feedback');
INSERT INTO `lang_base` VALUES ('_template','announcements','Announcements',NOW(),'course home page');
INSERT INTO `lang_base` VALUES ('_template','announcement_date_format','%%l %%F %%j, %%Y',NOW(),'course home page');
INSERT INTO `lang_base` VALUES ('_template','anonymous','Anonymous',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','anonymous_test','Anonymous',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','answer','Answer',NOW(),'test question add/edit screens');
INSERT INTO `lang_base` VALUES ('_template','answer_size','Answer Size',NOW(),'add/edit open ended question');
INSERT INTO `lang_base` VALUES ('_template','append_content','Append to existing content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','apply_theme_subcategories','Apply theme to subcategories.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','approval_error','Approval Error',NOW(),'links database admin (?)');
INSERT INTO `lang_base` VALUES ('_template','approve','Approve',NOW(),'enrol administration');
INSERT INTO `lang_base` VALUES ('_template','archive_total','Archive Total',NOW(),'file manager zip tool');
INSERT INTO `lang_base` VALUES ('_template','as_individual_content','As individual content pages',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','as_survey','as Survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','at','at',NOW(),'release date tool/links database');
INSERT INTO `lang_base` VALUES ('_template','attempts','Attempts',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','atutor_accessibility','ATutor Accessibility',NOW(),'help accessibility screen');
INSERT INTO `lang_base` VALUES ('_template','atutor_accessibility_text','<p>ATutor includes a variety of features designed to ensure that content is accessible to all potential users, including those with slow Internet connections, older Web browsers, and people with disabilities using assistive technologies to access the Web. These features are described in detail below.</p>\r\n\r\n<ol>\r\n	<li><b>ByPass Links:</b> In the top left corner of ATutor are a number of hidden bypass links that allow assistive technology users to skip over the navigation elements and jump directly to the content being displayed. Press the Tab key once after a page has finished loading to advance to the first bypass link then press Enter to reposition the content to the top of your screen. Alternatively, users can press the Tab key twice, then Enter to jump directly to the top menu array. Press the Tab key a third time to jump to the first Tab (Home) in the main navigation bar.  Press the Tab key a forth time to jump to the Accessibility page (this page) for information on configuring ATutor to work effectively with your assistive technology.<br /><br />\r\n\r\n[New in V1.3] The <strong>Menu Bypass</strong> link is dynamically generated to anchor to your last position in the content listings in the menu. To find your way back to a menu listing after opening or closing a menu item, tab into the page after it has finished loading until you reach the Menu Bypass link, then press Enter to jump directly the currently active menu item.\r\n</li>\r\n\r\n	<li><b>Default Accessibility Preference Configuration:</b> ATutor has a default accessibility configuration that hides all non-essential images and navigation tools when activated. <b>During registration</b> select \"Enable the Accessibility preferences scheme\" to load the default accessibility settings when you enter ATutor. This removes most of the images from ATutor, and closes the Menu, leaving a pair of sequence links as the primary navigation tools. ATutor\'s accessibility configuration can also be loaded by selecting the <b>Preset Preference</b> labelled  \"<a href=\"tools/preferences.php?pref_id=1\">Accessibility</a>\" near the top of the Preferences page. Screen reader users are advised to begin with this default preference setting and then modify those settings later through the Preferences page (if necessary).</li>\r\n\r\n	<li><b>Accesskeys:</b> Keyboard accessibility has been added to many ATutor features. To activate accesskeys, press Alt plus the assigned number or letter as follows:\r\n		<ul>\r\n			<li>[Alt 1] Home</li>\r\n			<li>[Alt 2] Tools</li>\r\n			<li>[Alt 3] Resources</li>\r\n			<li>[Alt 4] Discussions</li>\r\n			<li>[Alt 5] Sitemap</li>\r\n			<li>[Alt 6] Toggle menus open and closed</li>\r\n			<li>[Alt 7] Global Menu</li>\r\n			<li>[Alt 8] Previous topic</li>\r\n			<li>[Alt 9] Next topic</li>\r\n			<li>[Alt 0] Resume</li>\r\n			<li>[Alt y] Main Navigation</li>\r\n			<li>[Alt m] Menus</li>\r\n			<li>[Alt j] Jump Menu</li>\r\n			<li>[Alt s] Submit (active on form pages)</li>\r\n			<li>[Alt c] Jump to content top (top and bypass link)</li>\r\n		</ul>\r\n<p>Content Editor AccessKeys</p>\r\n<ul>\r\n<li>[Alt n] Content Tab</li>\r\n<li>[Alt p] Properties Tab</li>\r\n<li>[Alt g] Glossary Tab</li>\r\n<li>[Alt r] Preview Tab</li>\r\n<li>[Alt a] Accessibility Tab</li>\r\n</ul>\r\n<p>Chat AccessKeys</p>\r\n<ul>\r\n<li>[Alt c] Jump to Compose Message field</li>\r\n<li>[Alt r] Refresh Messages</li>\r\n<li>[Alt m] Jump to Message List</li>\r\n<li>[Alt q] Open Chat Help</li>\r\n\r\n</ul>\r\n	</li>\r\n	<li><b>Accessibility Verifier:</b> Using the ATutor Content Editor, instructors can check the accessibility of the content they create to be sure it will be accessibile to all learners, including those using assistive technologies, as well as those using older technologies to learn online.</li>\r\n	\r\n	<li><b>Alternative Text:</b> All images in ATutor include a text alternative that describes the image or its function.</li>\r\n	\r\n	<li><b>Alternative Navigation:</b> Global, hierarchical, and sequential navigation tools are available so users can view or structure content in a manner that suits their style of learning. See the Help pages or the ATutor HowTo course for more information about ATutor\'s navigation features.</li>\r\n	\r\n	<li><b>Hide Menus:</b> For users of older assistive technologies that do not support columnar text laid out in tables, it is possible to hide ATutor\'s menus so that content will be displayed in a linear presentation. Hiding menus also conserves space for users with smaller monitors.</li>\r\n	\r\n	<li><b>Text or Images:</b> ATutor users can choose to have navigational features displayed as either text, icons, or text and icons through a variety of preference settings.</li>\r\n	\r\n	<li><b>Form Labels:</b> All form fields throughout ATutor are marked up using the LABEL element to ensure that they are properly described for assistive technology users. Explicit labelling in this manner also makes it possible to click on a form field\'s label to activate the field. This provides a larger target area for those people who have difficulty positioning a mouse pointer on a small form field such as a radio button or a checkbox.</li>\r\n	\r\n	<li><b>Style Sheets:</b> Wherever possible, the presentation of content in ATutor is controlled by style sheet elements. This allows users to override ATutor\'s default appearance and apply their own preferred presentation styles (i.e. increased font sizes, different font styles, colours, etc.) </li>\r\n	\r\n	<li><b>Form Field Focus:</b> For pages where the primary content is a form, the mouse cursor will automatically be placed in the first field so that after a form page loads, it is not necessary to click or Tab into a field. Rather, users can begin typing text into the form as soon as the page has finished loading.</li>\r\n<li><b>Relative Sizing of Images:</b> [New in V1.3] With browsers that support resizing of images, ATutor icons can be magnified for user with low vision, making them more easily visible.  (e.g. Netscape 7 press Alt +) </li>\r\n\r\n\r\n</ol>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','atutor_administration','ATutor Administration',NOW(),'admin edit/delete screens');
INSERT INTO `lang_base` VALUES ('_template','atutor_content','ATutor Content',NOW(),'mini file manager frame title');
INSERT INTO `lang_base` VALUES ('_template','atutor_defaults','ATutor defaults',NOW(),'prefs');
INSERT INTO `lang_base` VALUES ('_template','atutor_help_boxes','<strong><em>ATutor Help Boxes:</em></strong> Help boxes are scattered throughout ATutor to explain how tools work, and to provide tips for getting the most effective use out of these tools. <strong><em>Enable or disable ATutor Help</em></strong> boxes by adjusting this setting in the Display Options of your <a href=\"users/preferences.php?g=12\">preferences</a>. After you have become familiar with ATutor, you may wish to disable the Help Boxes. Help is still easily accessible by clicking on the Help icons.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','atutor_help_window','ATutor Help Window',NOW(),'title for ATutor mini popup help window');
INSERT INTO `lang_base` VALUES ('_template','atutor_home','ATutor home',NOW(),'mail response link text');
INSERT INTO `lang_base` VALUES ('_template','atutor_is','<strong><em>ATutor</em></strong> is an Open Source Web-based <strong>Learning Content Management System (LCMS)</strong> designed with accessibility and adaptability in mind. Administrators can install or update ATutor in minutes. Educators can quickly assemble, package, and redistribute instructional content, and conduct their courses online. Students learn in an adaptive learning environment.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','atutor_links','<p>Learn more about <a href=\"http://atutor.ca/index.php\">ATutor</a> by browsing the following links:</p>\r\n\r\n<ul>\r\n<li><a href=\"http://www.atutor.ca/howto.php\">ATutor <em>HowTo</em> Course</a> - Learn how to use ATutor in this instructional course</li>\r\n<li><a href=\"http://atutor.ca/atutor/docs/index.php\">FAQs</a> - Frequently asked questions with answers</li>\r\n<li><a href=\"http://atutor.ca/forums/index.php\">Support Forums</a> - Post to the user forums</li>\r\n<li><a href=\"http://atutor.ca/services/index.php\">Support Services</a> - If you need our help, support is available</li>		\r\n<li><a href=\"http://atutor.ca/atutor/translate/index.php\">Translation</a> - Download language packs, become a translator</li>\r\n<li><a href=\"http://atutor.ca/services/licensing.php\">Licensing</a> - ATutor software is available for free under certain terms</li>\r\n<li><a href=\"http://atutor.ca/atutor/download.php\">Download ATutor</a> - All of the system software required to run ATutor can be downloaded here</li>\r\n</ul>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','atutor_sys_admin','ATutor System Administrator',NOW(),'administrator contact form for instructors');
INSERT INTO `lang_base` VALUES ('_template','at_tools','ATutor Tools',NOW(),'tracker column heading');
INSERT INTO `lang_base` VALUES ('_template','AT_WARNING_DELETE_POLL','Are you sure you want to delete this poll \'%s\'?  It cannot be recovered once deleted.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','auto_disable','Disabled - <a href=\"users/index.php?auto=enable\">enable auto-login</a>',NOW(),'control center / profile');
INSERT INTO `lang_base` VALUES ('_template','auto_enable','Enabled - <a href=\"users/index.php?auto=disable\">disable auto-login</a>',NOW(),'control centre / profile');
INSERT INTO `lang_base` VALUES ('_template','auto_login1','Auto-Login',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','auto_login2','Auto-Login: Next time log me in automatically.',NOW(),'login screen');
INSERT INTO `lang_base` VALUES ('_template','availability','Availablity',NOW(),'test manager column heading');
INSERT INTO `lang_base` VALUES ('_template','average','Average',NOW(),'test results / tracker courses statistics');
INSERT INTO `lang_base` VALUES ('_template','avg_duration','AVG Duration (sec)',NOW(),'tracker column heading');
INSERT INTO `lang_base` VALUES ('_template','back','Back',NOW(),'file manager back up to previous directory');
INSERT INTO `lang_base` VALUES ('_template','backup','Backup',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','backup_course','Backups',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','backup_course_text','Download, or restore, backups of courses or course content.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','back_to_summary','Back to Summary',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','back_to_top','Back to top',NOW(),'global back to top link');
INSERT INTO `lang_base` VALUES ('_template','bad_link','Bad LinkID, nothing returned',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','banner_styles','Banner Styles',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','banner_text','Create and edit this course\'s banner text and style.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','before_topic','Before: %s',NOW(),'content editor');
INSERT INTO `lang_base` VALUES ('_template','blue','Blue',NOW(),'global code picker tool');
INSERT INTO `lang_base` VALUES ('_template','blue_guests','Blue = Guests',NOW(),'instructor course statistics');
INSERT INTO `lang_base` VALUES ('_template','body','Body',NOW(),'add/edit forms for body field label');
INSERT INTO `lang_base` VALUES ('_template','bold','Bold',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','both_icons_and_text','Both icons and text',NOW(),'prefs');
INSERT INTO `lang_base` VALUES ('_template','bottom','Bottom',NOW(),'preference settings option');
INSERT INTO `lang_base` VALUES ('_template','browse_courses','Browse Courses',NOW(),'control centre, about, login screens');
INSERT INTO `lang_base` VALUES ('_template','browse_glossary','Browse the glossary by letter or view all.',NOW(),'glossary home page');
INSERT INTO `lang_base` VALUES ('_template','bytes','Bytes',NOW(),'admin course size quote, course properties screen');
INSERT INTO `lang_base` VALUES ('_template','cancel','Cancel',NOW(),'global cancel button');
INSERT INTO `lang_base` VALUES ('_template','category','Category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','category_ascending','Sort by category ascending.',NOW(),'admin view course switch Alt test');
INSERT INTO `lang_base` VALUES ('_template','category_descending','Sort by category descending',NOW(),'admin view courses switch Alt texrt');
INSERT INTO `lang_base` VALUES ('_template','category_name','Category Name',NOW(),'links database edit category screen');
INSERT INTO `lang_base` VALUES ('_template','cats_add_categories','Add Category',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_add_categories_2','Add Categories',NOW(),'admin add categories');
INSERT INTO `lang_base` VALUES ('_template','cats_add_subcategory','Add Subcategory',NOW(),'admin coruse categories');
INSERT INTO `lang_base` VALUES ('_template','cats_categories','Categories',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_category','Category',NOW(),'admin coruse categories');
INSERT INTO `lang_base` VALUES ('_template','cats_category_name','Category Name',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_course_categories','Course Categories',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_delete_categories','Delete Category',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_delete_category','Delete Category',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_edit_categories','Edit Category',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_edit_category','Edit Categories',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_go_to_category','Jump to single category display.',NOW(),'admin course categories bypass link alt text');
INSERT INTO `lang_base` VALUES ('_template','cats_new_category_name','New Category Name',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_none','None',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_no_categories','No Categories',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_no_course','No courses in this category.',NOW(),'admin course Categories');
INSERT INTO `lang_base` VALUES ('_template','cats_parent_category','Parent Category',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_show_all_courses','Show All Courses',NOW(),'course categories');
INSERT INTO `lang_base` VALUES ('_template','cats_show_course_categories','Show Course Categories',NOW(),'course_categories');
INSERT INTO `lang_base` VALUES ('_template','cats_uncategorized','Uncategorized',NOW(),'admin course categories');
INSERT INTO `lang_base` VALUES ('_template','cat_created','Category Created',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','cat_create_error','Error Creating Category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','cat_not_authorized','Not authorized for creating categories',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','cat_not_created','Category not created.',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','cat_theme','Category Theme',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','center','Center',NOW(),'global code picker option');
INSERT INTO `lang_base` VALUES ('_template','chat','Chat',NOW(),'global chat label');
INSERT INTO `lang_base` VALUES ('_template','chat_altc','Alt + C: Jump to Compose Message',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_altm','Alt + M: Jump to Messages',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_altq','Alt + Q:  Jump to Chat Help',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_altr','Alt + R: Refresh Messages',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_auto180_checking','Automatic (180 second interval)',NOW(),'chat message checking preference');
INSERT INTO `lang_base` VALUES ('_template','chat_auto20_checking','Automatic (20 second interval)',NOW(),'chat message checking preference');
INSERT INTO `lang_base` VALUES ('_template','chat_auto5_checking','Automatic (5 second interval)',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_auto60_checking','Automatic (60 second interval)',NOW(),'chat message checking preference');
INSERT INTO `lang_base` VALUES ('_template','chat_chime_help','Set to \"Yes\" to recieve an audio tone when new messsages are posted. Does not work in all Web browsers.',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_chime_no','No',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_chime_yes','Yes',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_compose_message','Compose Message',NOW(),'chat message compose frame');
INSERT INTO `lang_base` VALUES ('_template','chat_currently_active','Currently active',NOW(),'chat hompage transcript activated');
INSERT INTO `lang_base` VALUES ('_template','chat_current_tran','You may view the current transcript at',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_date','Date',NOW(),'chat homepage sorting');
INSERT INTO `lang_base` VALUES ('_template','chat_date_ascending','Date Ascending',NOW(),'chat home page sorting');
INSERT INTO `lang_base` VALUES ('_template','chat_date_descending','Date Descending',NOW(),'chat home page sorting');
INSERT INTO `lang_base` VALUES ('_template','chat_delete','Delete',NOW(),'chat homepage transcriipt delete');
INSERT INTO `lang_base` VALUES ('_template','chat_delete_transcript','Delete Transcript',NOW(),'chat home page');
INSERT INTO `lang_base` VALUES ('_template','chat_delete_transcript_confirm','Are you sure you want to delete this transcript?',NOW(),'instructor chat');
INSERT INTO `lang_base` VALUES ('_template','chat_edit_prefs','Edit Preferences',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_enter','Enter Chat',NOW(),'chat preferences pages');
INSERT INTO `lang_base` VALUES ('_template','chat_exit','Exit Chat',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_full_history','Full History',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_help','Help',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_help_display_blurb','<p>Note: <em>Jump To</em> links and the <em>Quick Key</em> list only appear if you have turned on <em>Navigation Aids</em> in you preferences.</p>\r\n \r\n<ul>\r\n	<li>The <em>Jump to Quick Keys</em> link at the top takes you to a list of quick keys for the Chat. </li>\r\n	<li>The <em>Message Area</em> displays the most recent messages (up to ten). </li>\r\n    <li>The <em>Jump to Messages</em> links take you to the beginning of the list of messages. (Alt+M) </li>\r\n    <li>The <em>Refresh Messages</em> link lets you check for new messages (Alt+R). </li>\r\n    <li>The <em>Compose Message</em> Field and <em>Send Button</em> let you enter and send messages (Alt+C to enter the Compose Field, Enter to send a completed message). </li>\r\n</ul>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_help_display_frame','Display Frame Help (top left)',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_display_jump','Jump to Display Frame Help',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_history_blurb','The <em>User List</em> shows the Chat IDs of all the users in the chat. Click on a Chat ID to see the messages sent by that participant, along with your own messages. Click on <em>All Users</em> to see the messages sent by all participants.',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_history_frame','User List and History Help',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_history_jump','Jump to User List and History Help',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_jump_top','Jump to Top',NOW(),'chat_help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_options_blurb','<ul>\r\n	<li>The <em>Edit Preferences</em> link opens the preferences so you can modify your control and display settings. </li>\r\n    <li>The <em>Exit Chat</em> link ends your chat session.</li>\r\n    <li>The <em>Help</em> link brings you to this screen. (Alt+Q)</li>\r\n</ul>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_help_options_frame','Options Help (top right)',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_options_jump','Jump to Options Help',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_help_screen','Help Screen',NOW(),'chat help');
INSERT INTO `lang_base` VALUES ('_template','chat_history_messages','History - Messages %s to %s of %s',NOW(),'chat full history screen');
INSERT INTO `lang_base` VALUES ('_template','chat_jump_to_message','Jump to Message Area',NOW(),'chat display frame');
INSERT INTO `lang_base` VALUES ('_template','chat_keep_tran','This section allows you to keep a transcript of the chat in progress.',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_keep_tran1','keep a transcript',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_last_tran','Last produced transcript at:',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_layout_prefs','Preferences: Layout Settings',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_list_and_history','User List and History',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_logged_out','User %s has logged out.',NOW(),'logout');
INSERT INTO `lang_base` VALUES ('_template','chat_manual_checking','Manual Refresh',NOW(),'chat message checking preference');
INSERT INTO `lang_base` VALUES ('_template','chat_messages','Messages',NOW(),'chat message display frame');
INSERT INTO `lang_base` VALUES ('_template','chat_message_checking','Message Checking:',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_message_check_help','Select the interval rate at which new messages are retrieved from the server. Screen reader users set this option to Manual Refresh.',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_message_chime','New Message Chime:',NOW(),'chat message checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_message_new_help','Screen reader users choose \"Yes\", along with the Manual Refresh setting.',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_message_order_help','Select New to Old to display new messages at the top of the screen, and Old to New to display new messages at the bottom of the screen.',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_name','Name',NOW(),'chat home page sort by name heading');
INSERT INTO `lang_base` VALUES ('_template','chat_name_ascending','Name Ascending',NOW(),'chat home page');
INSERT INTO `lang_base` VALUES ('_template','chat_name_descending','Name Descending',NOW(),'chat home page sort by');
INSERT INTO `lang_base` VALUES ('_template','chat_newmsg_no','No',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_newmsg_prefs','Show Only New Messages?',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_newmsg_yes','Yes',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_newold_prefs','New to Old',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_next','Next',NOW(),'chat preferences pages');
INSERT INTO `lang_base` VALUES ('_template','chat_none_found','None Found.',NOW(),'chat home page');
INSERT INTO `lang_base` VALUES ('_template','chat_no_new_messages','No new messages.',NOW(),'chat display frames');
INSERT INTO `lang_base` VALUES ('_template','chat_oldnew_prefs','Old to New',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_options','Options',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_order_prefs','Order of Messages:',NOW(),'chat layout preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_post','Enter: Post a completed message',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_prefs_checking','Preferences: Message Checking Settings',NOW(),'chat checking preferences');
INSERT INTO `lang_base` VALUES ('_template','chat_previous','Previous',NOW(),'chat preferences previous button');
INSERT INTO `lang_base` VALUES ('_template','chat_quick_keys','Quick Keys',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_refresh_message','Refresh Messages',NOW(),'chat display frame');
INSERT INTO `lang_base` VALUES ('_template','chat_refresh_user_list','Refresh User List',NOW(),'chat options frame');
INSERT INTO `lang_base` VALUES ('_template','chat_return','Return to Chat',NOW(),'chat help screen');
INSERT INTO `lang_base` VALUES ('_template','chat_room','Chat Room',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','chat_send','Send',NOW(),'chat send button');
INSERT INTO `lang_base` VALUES ('_template','chat_settings','Chat Settings',NOW(),'admin');
INSERT INTO `lang_base` VALUES ('_template','chat_sort_by_date','Sort by Date',NOW(),'chat home page sorting');
INSERT INTO `lang_base` VALUES ('_template','chat_sort_by_name','Sort by Name',NOW(),'chat home page sorting');
INSERT INTO `lang_base` VALUES ('_template','chat_start_tran','Start keeping a transcript',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_start_tran1','keep a transcript',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_stop_tran','Stop keeping transcript.',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_system','system',NOW(),'chat display frame system message');
INSERT INTO `lang_base` VALUES ('_template','chat_template','<u>C</u>hat Room',NOW(),'main navigation across the top');
INSERT INTO `lang_base` VALUES ('_template','chat_text','Chat with others from this course who are online right now.',NOW(),'discussions chat');
INSERT INTO `lang_base` VALUES ('_template','chat_transcript','Transcript',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_transcript_end','Transcript End:',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_transcript_start','Transcript Start:',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_tran_file_name','Transcript name (alphanumeric, no spaces):',NOW(),'achat');
INSERT INTO `lang_base` VALUES ('_template','chat_user_logged_in','User %s has logged in.',NOW(),'chat display system login message');
INSERT INTO `lang_base` VALUES ('_template','chat_user_logged_out','User %s has been logged out due to inactivity.',NOW(),'chat logout system message');
INSERT INTO `lang_base` VALUES ('_template','chat_use_headings_to_sort','Use the column headings to sort by that column.',NOW(),'chat home page transcript sort instructions');
INSERT INTO `lang_base` VALUES ('_template','chat_window','(Chat opens in a new window.)',NOW(),'discussions page chat window warning');
INSERT INTO `lang_base` VALUES ('_template','chat_you','you',NOW(),'chat users online list');
INSERT INTO `lang_base` VALUES ('_template','check_latest_version','Check Latest Version',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','child_of','Child of: %s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','choice','Choice',NOW(),'test manager, multiple choice question editor');
INSERT INTO `lang_base` VALUES ('_template','cid','CID',NOW(),'global code picker url content id indentifier');
INSERT INTO `lang_base` VALUES ('_template','city','City',NOW(),'registration, edit profile');
INSERT INTO `lang_base` VALUES ('_template','click_code','Click on the code or emoticon you want to use.',NOW(),'global code picker instructions');
INSERT INTO `lang_base` VALUES ('_template','click_concept','Click on Learning Concepts to insert them in your content, or type in the associated [code]',NOW(),'global code picker instructions');
INSERT INTO `lang_base` VALUES ('_template','Close','Close',NOW(),'file upload progress window');
INSERT INTO `lang_base` VALUES ('_template','close_after_saving','Close after saving',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','close_frame','Close File Manager',NOW(),'mini filemanger frame');
INSERT INTO `lang_base` VALUES ('_template','close_global_menu','Close Global Menu',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_glossary_terms','Close Glossary Terms',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_help','Close Help',NOW(),'help box icon alt text');
INSERT INTO `lang_base` VALUES ('_template','close_help_window','Close Help Window',NOW(),'close help window link text');
INSERT INTO `lang_base` VALUES ('_template','close_local_menu','Close Local Menu',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_menu','Close Menu',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_menus','Close Menus',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_poll','Close Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','close_related_topics','Close Related Topics',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','close_search','Close Search',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','close_users_online','Close Users Online',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','codes','Codes',NOW(),'global code picker label');
INSERT INTO `lang_base` VALUES ('_template','collapse','Collapse',NOW(),'Menus');
INSERT INTO `lang_base` VALUES ('_template','colors','Colours',NOW(),'global code picker label');
INSERT INTO `lang_base` VALUES ('_template','color_theme','Colour Theme',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','combination','Use a combination of letters, numbers and symbols',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','completed_tests','Completed Tests &amp; Surveys - Grouped by Course',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','contacts','Contacts',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','contact_admin','Contact Administrator',NOW(),'instructor contact admin form');
INSERT INTO `lang_base` VALUES ('_template','contact_admin_form','Administrator Contact Form',NOW(),'instructor contact admin form');
INSERT INTO `lang_base` VALUES ('_template','contact_instructor','Contact Course Instructor',NOW(),'student contact instructor form');
INSERT INTO `lang_base` VALUES ('_template','contact_instructor_form','Instructor Contact Form',NOW(),'student contact instructor form');
INSERT INTO `lang_base` VALUES ('_template','contact_instructor_moved','Contact Instructor has been moved to the <a href=\"users/index.php\">My Courses</a> section.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','contact_name','Contact Name',NOW(),'student contact instructor form');
INSERT INTO `lang_base` VALUES ('_template','contain_only','May contain only letters, numbers, or underscores.',NOW(),'registration login name format');
INSERT INTO `lang_base` VALUES ('_template','content','Content',NOW(),'sitemap/delete course');
INSERT INTO `lang_base` VALUES ('_template','contents','Contents',NOW(),'content page table of content menu heading');
INSERT INTO `lang_base` VALUES ('_template','content_icons','Content Icons',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','content_packaging','Content Packaging',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','content_packaging_all','Available on every page',NOW(),'option3');
INSERT INTO `lang_base` VALUES ('_template','content_packaging_disabled','Content packaging has been disabled for this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','content_packaging_none','Not available on any of the pages',NOW(),'option1');
INSERT INTO `lang_base` VALUES ('_template','content_packaging_text','Export and import standards compliant content packages.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','content_packaging_top','Available only for top level pages',NOW(),'option2');
INSERT INTO `lang_base` VALUES ('_template','content_selector','Content Selector',NOW(),'print compiler');
INSERT INTO `lang_base` VALUES ('_template','context_sensative_help_text','<strong><em>Context Sensitive Help:</em></strong> On tools pages the mini help icon [ <img src=\"images/help3.gif\" alt=\"Example mini help icon\" height=\"15\" width=\"16\" /> ] will appear beside various fields to indicate how a field is intended to be used. Hover over the icon with a mouse pointer to display the accompanying help, or click on the icon to open the help in a new window. For browsers that support the \"<strong>title</strong>\" attribute in various HTML elements, holding a mouse pointer over an icon or a link will often give you extra information about the tool, such as its accesskey. Example:',NOW(),'help/about_help');
INSERT INTO `lang_base` VALUES ('_template','continue','Continue',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','control_centre','Control Centre',NOW(),'control center heading');
INSERT INTO `lang_base` VALUES ('_template','copyright','Web site engine\'s code is copyright &copy; 2001-2004 <a href=\"http://www.atutor.ca\" target=\"_new\" title=\"ATutor.ca - opens in a new browser\">ATutor</a><sup>&#174;</sup>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','copyright_text','Edit this course\'s Copyright notice.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','copyright_txt2','Add a copyright message to be displayed at the bottom of this course.  Leave blank if you do not wish a notice to appear.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','correct_answer','Correct Answer',NOW(),'test manager add/edit questions');
INSERT INTO `lang_base` VALUES ('_template','could_not_read','could not read file',NOW(),'stylesheet editor ');
INSERT INTO `lang_base` VALUES ('_template','count','Count',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','country','Country',NOW(),'registration / profile edit');
INSERT INTO `lang_base` VALUES ('_template','course','Course',NOW(),'delete course warning screen');
INSERT INTO `lang_base` VALUES ('_template','courses','Courses',NOW(),'admin users/courses manager');
INSERT INTO `lang_base` VALUES ('_template','courses_below','Courses Below',NOW(),'jump menu divider');
INSERT INTO `lang_base` VALUES ('_template','courses_for_login','Courses for instructor %s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_available','Course Available',NOW(),'file manager, server space available');
INSERT INTO `lang_base` VALUES ('_template','course_available_zip1','Course Available (before extraction)',NOW(),'file manager zip tool');
INSERT INTO `lang_base` VALUES ('_template','course_available_zip2','Course Available (after extraction)',NOW(),'file manager zip tool');
INSERT INTO `lang_base` VALUES ('_template','course_banner','Course Banner (formerly \'Header Editor\')',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_copyright','Optional Copyright Notice',NOW(),'course copyright label');
INSERT INTO `lang_base` VALUES ('_template','course_copyright2','Course Copyright',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_defaults','Apply Course Default Settings',NOW(),'preferences screens, when course defaults are set');
INSERT INTO `lang_base` VALUES ('_template','course_default_prefs','Course Default Preferences',NOW(),'instructor tools - course preferences');
INSERT INTO `lang_base` VALUES ('_template','course_default_prefs_text','Create and edit this course\'s default preferences.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','course_email','Course Email',NOW(),'taught courses table in instructor control centre');
INSERT INTO `lang_base` VALUES ('_template','course_enrollment_text','Import and export course lists, manage enrolled users and user privileges.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_enrolment','Enrollment Manager',NOW(),'instructor - course enrollment (previously ATutor Course Enrollment)');
INSERT INTO `lang_base` VALUES ('_template','course_header','Course Header',NOW(),'instructor header editor');
INSERT INTO `lang_base` VALUES ('_template','course_id','Course ID',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','course_information','Course Information',NOW(),'create course, course properties');
INSERT INTO `lang_base` VALUES ('_template','course_instructor','Course Instructor',NOW(),'student contact instructor form');
INSERT INTO `lang_base` VALUES ('_template','course_materialsAuto','Course Materials File',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','course_name','Course Name',NOW(),'browse courses, create course, course properties');
INSERT INTO `lang_base` VALUES ('_template','course_nav','Course Navigation',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_properties','Course Properties',NOW(),'course properties, admin course manager');
INSERT INTO `lang_base` VALUES ('_template','course_properties_text','Manage this course\'s title, category, access level, and more.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_quota','Course Quota',NOW(),'course properties, admin course manager');
INSERT INTO `lang_base` VALUES ('_template','course_settings','Course Settings',NOW(),'course properties title');
INSERT INTO `lang_base` VALUES ('_template','course_stats','Course Statistics',NOW(),'delete course');
INSERT INTO `lang_base` VALUES ('_template','course_styles','Course Styles',NOW(),'instructor stylesheet editor');
INSERT INTO `lang_base` VALUES ('_template','course_summaries','Course Summaries',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','course_total','Course Total',NOW(),'file manager, zip tool');
INSERT INTO `lang_base` VALUES ('_template','course_total_zip','Course Total (before extraction)',NOW(),'file manager zip tool');
INSERT INTO `lang_base` VALUES ('_template','course_tracker','Course Tracker',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','course_tracker_text','Review student navigation tendencies and click paths, as well as page usage statistics.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','create','Create',NOW(),'links database submit button');
INSERT INTO `lang_base` VALUES ('_template','created','Created',NOW(),'browse courses, control centre');
INSERT INTO `lang_base` VALUES ('_template','created_date','Created',NOW(),'admin course managers, profile editor');
INSERT INTO `lang_base` VALUES ('_template','created_date_ascending','Order by Created Date Ascending',NOW(),'admin course manager column header');
INSERT INTO `lang_base` VALUES ('_template','created_date_descending','Order by Created Date Descending',NOW(),'admin course manager column heading');
INSERT INTO `lang_base` VALUES ('_template','create_anchor','Create an anchor using [cid]#myanchor',NOW(),'global code picker CID title text');
INSERT INTO `lang_base` VALUES ('_template','create_and_download_course_backup','Create and Download Course Backup',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','create_course','Create a New Course',NOW(),'instructor control centre');
INSERT INTO `lang_base` VALUES ('_template','create_folder','Create Folder',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','create_test','Create Test',NOW(),'instructor test manager');
INSERT INTO `lang_base` VALUES ('_template','css_background_colour','Background Colour',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_background_image','Background Image URL',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_font_colour','Font Colour',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_font_family','Font Family',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_font_size','Font Size',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_font_weight','Font Weight',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_horizontal_alignment','Horizontal Alignment',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_only',' CSS files only.',NOW(),'instructor stylesheet editor');
INSERT INTO `lang_base` VALUES ('_template','css_padding','Padding',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','css_vertical_alignment','Vertical Alignment',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','current_course_size','Current course size',NOW(),'admin course info');
INSERT INTO `lang_base` VALUES ('_template','current_location','(Current location)',NOW(),'content editor');
INSERT INTO `lang_base` VALUES ('_template','current_path','Path to Current Directory:',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','curren_tests_surveys','On Going Tests &amp; Surveys',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','custom','Custom',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','date','Date',NOW(),'global date label');
INSERT INTO `lang_base` VALUES ('_template','date_apr','Apr',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_april','April',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_aug','Aug',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_august','August',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_created','Date Created',NOW(),'view profile');
INSERT INTO `lang_base` VALUES ('_template','date_dec','Dec',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_december','December',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_feb','Feb',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_february','February',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_fri','Fri',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_friday','Friday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_jan','Jan',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_january','January',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_jul','Jul',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_july','July',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_jun','Jun',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_june','June',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_mar','Mar',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_march','March',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_may','May',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_may_short','May',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_mon','Mon',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_monday','Monday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_nov','Nov',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_november','November',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_oct','Oct',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_october','October',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_of_birth','Date of birth',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','date_sat','Sat',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_saturday','Saturday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_sep','Sep',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_september','September',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_sun','Sun',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_sunday','Sunday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_taken','Date Taken',NOW(),'My Tests');
INSERT INTO `lang_base` VALUES ('_template','date_thu','Thu',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_thursday','Thursday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_tue','Tue',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_tuesday','Tuesday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_wed','Wed',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','date_wednesday','Wednesday',NOW(),'date');
INSERT INTO `lang_base` VALUES ('_template','day','Day',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','default','Default',NOW(),'edit header/admin course manager');
INSERT INTO `lang_base` VALUES ('_template','default_announcement','This is some default content. See the <a href=\"../help/about_help.php\">About ATutor Help</a> for sources of information about using ATutor.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','default_max','Default values for Course Quota and Max File Size are defined in <code>config.inc.php</code> in the <code>include/</code> directory. See <a href=\"http://atutor.ca\">ATutor.ca</a> for official documentation.',NOW(),'admin course manager disk use quota');
INSERT INTO `lang_base` VALUES ('_template','definition','Definition',NOW(),'text for mouseover glossary popups');
INSERT INTO `lang_base` VALUES ('_template','delete','Delete',NOW(),'global delete label');
INSERT INTO `lang_base` VALUES ('_template','deleted','Deleted',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','delete_announcement','Delete Announcement',NOW(),'delete news screen');
INSERT INTO `lang_base` VALUES ('_template','delete_category','Delete Category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','delete_content','Delete Content',NOW(),'delete content screen');
INSERT INTO `lang_base` VALUES ('_template','delete_course','Delete Course',NOW(),'delete course screen');
INSERT INTO `lang_base` VALUES ('_template','delete_forum','Delete Forum',NOW(),'instructor delete forum screen');
INSERT INTO `lang_base` VALUES ('_template','delete_language','Delete Language',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','delete_page','Delete This Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','delete_poll','Delete Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','delete_question','Delete Question',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','delete_results','Delete Test Results',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','delete_test','Delete Test/Survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','delete_this_term','Delete This Term',NOW(),'glossary delete term page heading');
INSERT INTO `lang_base` VALUES ('_template','delete_this_term1','Delete Glossary Term',NOW(),'content editor delete glossary term');
INSERT INTO `lang_base` VALUES ('_template','delete_thread','Delete Thread',NOW(),'forums');
INSERT INTO `lang_base` VALUES ('_template','delete_user','Delete User',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','deleting_course','Deleting course ...',NOW(),'deleting course status message');
INSERT INTO `lang_base` VALUES ('_template','depth_reached','Directory depth limit has been reached.',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','description','Description',NOW(),'global description label');
INSERT INTO `lang_base` VALUES ('_template','details','Details',NOW(),'instructor taught course table of the control panel');
INSERT INTO `lang_base` VALUES ('_template','directory_name','Directory Name',NOW(),'file manager zip utility');
INSERT INTO `lang_base` VALUES ('_template','directory_total','Directory Total',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','disabled_theme','Disabled - turn off Override Theme',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','disable_editor','Disable Editor',NOW(),'text label for instructor\'s editor switch in the login menu');
INSERT INTO `lang_base` VALUES ('_template','disapproval_error','Disapproval Error',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','disapprove','Disapprove',NOW(),'enrolment manager');
INSERT INTO `lang_base` VALUES ('_template','disapproved','Disapproved',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','discussions','Discussions',NOW(),'global text for discussions label');
INSERT INTO `lang_base` VALUES ('_template','display','Display',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','disp_options','Display Options',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','done','Done',NOW(),'enrolment manager');
INSERT INTO `lang_base` VALUES ('_template','dont_mark','Do not mark (e.g. survey)',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','download','Download',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','download_test_csv','CSV Download Statistics',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','duration','Duration',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','duration_sec','Duration (sec)',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','edit','Edit',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','editor','Editor',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','editor_keywords','Carefully create keywords or phrases, separated by commas, that describe the main ideas on this content page. Keywords are used for searching.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','editor_on','Editor',NOW(),'editor icon alt text');
INSERT INTO `lang_base` VALUES ('_template','editor_properties_instructions','Use the %1$s and %2$s buttons to place this topic after or before the selected location, respectively. Use the %3$s button to add this topic as a child of the selected location.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','editor_properties_insturctions_related','Add Related Topics by selecting the topic from the list.',NOW(),'editor properties instructions');
INSERT INTO `lang_base` VALUES ('_template','edit_after_upload',' After uploaded use the fields below to edit the content.',NOW(),'cotent editor');
INSERT INTO `lang_base` VALUES ('_template','edit_announcement','Edit Announcement',NOW(),'instructor announcement editor');
INSERT INTO `lang_base` VALUES ('_template','edit_category','Edit Category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','edit_content','Edit Content',NOW(),'instructor content editor');
INSERT INTO `lang_base` VALUES ('_template','edit_forum','Edit Forum',NOW(),'instructor forum editor');
INSERT INTO `lang_base` VALUES ('_template','edit_glossary','Edit Glossary Term',NOW(),'instructor edit glossary term screen');
INSERT INTO `lang_base` VALUES ('_template','edit_import','Import IMS or SCORM content package as subcontent',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','edit_link','Edit Link',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','edit_lk_question','Edit Likert Question',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','edit_mc_question','Edit Multiple Choice Question in',NOW(),'test manager, question editor');
INSERT INTO `lang_base` VALUES ('_template','edit_mc_question2','Edit Multiple Choice Question',NOW(),'Test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_open_question','Edit Open Ended Question in',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_open_question1','Edit Open Ended Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_page','Edit This Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','edit_poll','Edit Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','edit_post','Edit Post',NOW(),'instructor edit forum post');
INSERT INTO `lang_base` VALUES ('_template','edit_preferences','Edit Preferences',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','edit_profile','Edit Profile',NOW(),'profile editor');
INSERT INTO `lang_base` VALUES ('_template','edit_question','Edit Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_resource_in','Edit a Resource in',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','edit_test','Edit Test/Survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','edit_tf_question','Edit True or False Question in',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_tf_question1','Edit True or False Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','edit_this_term','Edit This Term',NOW(),'glossary');
INSERT INTO `lang_base` VALUES ('_template','edit_user','Edit Member',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','email','Email',NOW(),'global email label');
INSERT INTO `lang_base` VALUES ('_template','email_address','Email Address',NOW(),'profile, password reminder');
INSERT INTO `lang_base` VALUES ('_template','email_approvals','Email me when new enrollments require approval.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','emoticons','Emoticons',NOW(),'code picker');
INSERT INTO `lang_base` VALUES ('_template','empty','empty',NOW(),'prefs page, menu options');
INSERT INTO `lang_base` VALUES ('_template','enable visual','Enable Visual Editor',NOW(),'Visual Editor Option');
INSERT INTO `lang_base` VALUES ('_template','enable_accessibility','Enable Default Accessibility Preference Settings',NOW(),'registration screen');
INSERT INTO `lang_base` VALUES ('_template','enable_editor','Enable Editor',NOW(),'instructor enable editor link text');
INSERT INTO `lang_base` VALUES ('_template','end_date','End Date',NOW(),'mytests');
INSERT INTO `lang_base` VALUES ('_template','end_section','To End of Section',NOW(),'instructor add content screen');
INSERT INTO `lang_base` VALUES ('_template','enroll','Enroll',NOW(),'link text for enroll function');
INSERT INTO `lang_base` VALUES ('_template','enrolled','Enrolled',NOW(),'control centre, delete course, admin course manager, text label');
INSERT INTO `lang_base` VALUES ('_template','enrolled_courses','Enrolled Courses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','enrolment','Enrollment',NOW(),'instructor control centre');
INSERT INTO `lang_base` VALUES ('_template','enrolments','Enrollment',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','enrol_login','You must login to your Control Centre to approve the new enrollment request.',NOW(),'instructor enrolment screen ');
INSERT INTO `lang_base` VALUES ('_template','enrol_message1','Your enrollment request for the ATutor course',NOW(),'context (remove after v1.1) ');
INSERT INTO `lang_base` VALUES ('_template','enrol_message2','and login.',NOW(),'context (removed after V1.1)');
INSERT INTO `lang_base` VALUES ('_template','enrol_message3','ATutor Course Enrollment',NOW(),'context');
INSERT INTO `lang_base` VALUES ('_template','enrol_messagenew','An enrollment request was made for the ATutor course %s. Log into your Control Centre at %s , and click on \"pending approval\" in your Taught Courses table.',NOW(),'instructor enrolment email notice');
INSERT INTO `lang_base` VALUES ('_template','enrol_message_approved','Your enrollment request for the course %s has been approved. Log into your ATutor Control Centre at: %s then access the course through its listing in your Enrolled Courses table.',NOW(),'email message sent to enrollee once approved');
INSERT INTO `lang_base` VALUES ('_template','enrol_message_subject','Course enrollment approved',NOW(),'enroll email approval');
INSERT INTO `lang_base` VALUES ('_template','enrol_msg','A new enrollment request has been made for your ATutor course %s.',NOW(),'instructor email enrollment notification message');
INSERT INTO `lang_base` VALUES ('_template','enter_chat','Enter the Chat',NOW(),'achat entry page');
INSERT INTO `lang_base` VALUES ('_template','error','Error',NOW(),'global error label');
INSERT INTO `lang_base` VALUES ('_template','expand','Expand',NOW(),'menu toggle alt text');
INSERT INTO `lang_base` VALUES ('_template','expired','Expired',NOW(),'mytests');
INSERT INTO `lang_base` VALUES ('_template','export','Export',NOW(),'instructor control centre');
INSERT INTO `lang_base` VALUES ('_template','exporting','Exporting',NOW(),'instructor export tool status message');
INSERT INTO `lang_base` VALUES ('_template','export_about','The ATutor Export tool will send you a single archived file containing all of your course materials. The file format is a zip, and requires special software to open it. The contents of that file is in the particular format required for Importing content. Do not attempt to edit the exported file unless you know what you are doing.',NOW(),'instructor export screen');
INSERT INTO `lang_base` VALUES ('_template','export_backup','Export Backup',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_backup_about','Creating a course backup will contain all the files need to restore or transfer the entire course as a whole from one ATutor server to another. The format of the backup file is unique to ATutor and is only for the purposes of backing up entire courses.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_content','Export Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_content_package','Export Content Package',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_content_package_about','Exporting a content package will create a standards compliant archive of the selected content. The package contains a viewer allowing you to browse the content on your computer, or alternatively, you may upload the entire package as a whole into a different course or system.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_content_package_what','What to export',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_content_text','Export viewable standards compliant content packages.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','export_course','Export Course Materials',NOW(),'instructor export screen');
INSERT INTO `lang_base` VALUES ('_template','export_entire_course_or_chap','Entire course, or select a chapter below',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','extract','Extract',NOW(),'file manager zip utility');
INSERT INTO `lang_base` VALUES ('_template','extract_archive','Extract Archive',NOW(),'file manager zip utility');
INSERT INTO `lang_base` VALUES ('_template','extract_tip','Tip: Use an empty directory name to extract the contents into the current directory.',NOW(),'file manager zip utility');
INSERT INTO `lang_base` VALUES ('_template','false','False',NOW(),'textmanager, mytests t/f label');
INSERT INTO `lang_base` VALUES ('_template','feedback','Feedback',NOW(),'global feedback label');
INSERT INTO `lang_base` VALUES ('_template','female','Female',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','file','File',NOW(),'file manager, zip tool');
INSERT INTO `lang_base` VALUES ('_template','filemanager_date_format','%%Y-%%m-%%d %%h:%%i',NOW(),'file manager date');
INSERT INTO `lang_base` VALUES ('_template','file_content_frame','Content Frame',NOW(),'file manager frame content frame title');
INSERT INTO `lang_base` VALUES ('_template','file_manager','File Manager',NOW(),'global file manager label');
INSERT INTO `lang_base` VALUES ('_template','file_manager_frame','ATutor - File Manager Frame',NOW(),'link text in file manager frame');
INSERT INTO `lang_base` VALUES ('_template','file_manager_text','Upload and manage this course\'s files.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','find_results_in','Find results in',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','first_name','First Name',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','first_name_ascending','Order by First Name Ascending',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','first_name_descending','Order by First Name Descending',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','folder','Folder',NOW(),'file manager, zip utility');
INSERT INTO `lang_base` VALUES ('_template','font_theme','Font Theme',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','forgot','Forgot your password or login?',NOW(),'login screen');
INSERT INTO `lang_base` VALUES ('_template','formatting','Formatting',NOW(),'add/ edit content, news, export');
INSERT INTO `lang_base` VALUES ('_template','forum','Forum',NOW(),'Forum list header');
INSERT INTO `lang_base` VALUES ('_template','forums','Forums',NOW(),'global forums label');
INSERT INTO `lang_base` VALUES ('_template','forums_text','Post, read, and respond to forum messages for this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','forum_date_format','%%D %%M %%j %%H:%%i',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','forum_description','Forum Description',NOW(),'forums home page, discussions');
INSERT INTO `lang_base` VALUES ('_template','forum_email_links','All email addresses are made into links.',NOW(),'forums email address links instruction');
INSERT INTO `lang_base` VALUES ('_template','forum_html_disabled','HTML is disabled.',NOW(),'forum compose message');
INSERT INTO `lang_base` VALUES ('_template','forum_links','All words starting with http:// are made into links.',NOW(),'forum compose link creation instruction');
INSERT INTO `lang_base` VALUES ('_template','forum_new_submsg','A discussion thread in the ATutor course \"%s\" has recieved a reply. Login to access the \"%s\" forum and view the \"%s\" thread. Login at: %s',NOW(),'forum email message to thread subscribers');
INSERT INTO `lang_base` VALUES ('_template','forum_reply_to','Replying To',NOW(),'forum reply to label for quoted messages');
INSERT INTO `lang_base` VALUES ('_template','forum_threads','Forum Threads',NOW(),'forum thread list page');
INSERT INTO `lang_base` VALUES ('_template','forum_title','Forum Title',NOW(),'instructor add/edit forum');
INSERT INTO `lang_base` VALUES ('_template','forum_topics','Topics',NOW(),'Header for topics in forum list');
INSERT INTO `lang_base` VALUES ('_template','for_instructors','For Instructors Only:',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','frame_contains','This frameset document contains:',NOW(),'file manager frameset title');
INSERT INTO `lang_base` VALUES ('_template','free_account','Create an account here',NOW(),'login screen');
INSERT INTO `lang_base` VALUES ('_template','from','From',NOW(),'global from label');
INSERT INTO `lang_base` VALUES ('_template','from_atutor','This message was sent through the ATutor system from course %s.',NOW(),'instructor/admin contact for email message');
INSERT INTO `lang_base` VALUES ('_template','from_email','From Email',NOW(),'instructor/admin contact form');
INSERT INTO `lang_base` VALUES ('_template','from_name','From Name',NOW(),'instrcutor/admin contact from');
INSERT INTO `lang_base` VALUES ('_template','gender','Sex',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','general_help','For general help with using the ATutor system see the official <a href=\"http://www.atutor.ca/howto.php\">ATutor <em>HowTo</em>  course</a>.',NOW(),'atutor default footer');
INSERT INTO `lang_base` VALUES ('_template','general_statistics','General Statistics',NOW(),'admin home page');
INSERT INTO `lang_base` VALUES ('_template','give_description','Brief description of your proposed course (REQUIRED):',NOW(),'control centre request instructor account form');
INSERT INTO `lang_base` VALUES ('_template','glossary','Glossary',NOW(),'global glossary label');
INSERT INTO `lang_base` VALUES ('_template','glossary_definition','Definition',NOW(),'glossary add/edit term');
INSERT INTO `lang_base` VALUES ('_template','glossary_item','Glossary Item',NOW(),'code picker glossary code link text');
INSERT INTO `lang_base` VALUES ('_template','glossary_related','Related Term',NOW(),'add/edit glossary term');
INSERT INTO `lang_base` VALUES ('_template','glossary_term','Term',NOW(),'add/edit glossary term');
INSERT INTO `lang_base` VALUES ('_template','glossary_terms','Glossary Terms',NOW(),'delete course feedback for terms deleted');
INSERT INTO `lang_base` VALUES ('_template','glossary_text','Definitions for terms and phrases used in this course.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','goto_accessibility','Skip to Accessibility Features Page:',NOW(),'Alt text for accessibility bypass link in the ATutor header');
INSERT INTO `lang_base` VALUES ('_template','goto_content','Go to content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','goto_mainnav','Skip to Main Navigation:',NOW(),'bypass link text in ATutor header');
INSERT INTO `lang_base` VALUES ('_template','goto_menu','Skip to the Menu:',NOW(),'bypass link text in ATutor header');
INSERT INTO `lang_base` VALUES ('_template','goto_top','Go to Top',NOW(),'bypass link text in ATutor header');
INSERT INTO `lang_base` VALUES ('_template','graph','Graph',NOW(),'instructor course details graph label');
INSERT INTO `lang_base` VALUES ('_template','gray','Gray',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','green','Green',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','grouped_by_course','Grouped by course',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','groups_shortcut','Shortcut to Course Groups',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','guest','Guest',NOW(),'name assigned to non-registered users');
INSERT INTO `lang_base` VALUES ('_template','guests','Guests',NOW(),'instructor course stats/details');
INSERT INTO `lang_base` VALUES ('_template','guests_not_listed','Guests are not listed',NOW(),'who\'s on menu');
INSERT INTO `lang_base` VALUES ('_template','g_breadcrumb','Breadcrumb',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_chat','Chat',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_content_packaging','Content Packaging',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','g_discussions','Discussions',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_download_tracking_csv','Download tracking data in a CSV file.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_download_tracking_csv_desc','Import the raw tracking data into a spreadsheet application, or database table, to do your own study of usage patterns. Or, archive CSV files after each session to create a course usage history.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_embedded_glossary','Embedded Glossary',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_embedded_links','Embedded links',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_forum_reply','Forum Reply',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_from_tracker','From Tracker',NOW(),'tracker nav tendencies');
INSERT INTO `lang_base` VALUES ('_template','g_global_home','Global Home link',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_global_menu','Global Menu',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_headings','Headings',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_help','Help',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_home','Home',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_inbox','Inbox',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_jump','Jump',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_links_db','Links DB',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_local_home','Local Home link',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_local_major_topic','Local major topic',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_local_menu','Local Menu',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_logout','Logout',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_menu_glossary','Menu glossary',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_mytests','MyTests',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_my_tracker','My Tracker',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_new_thread','New Thread',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_preferences','Preferences',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_print_compiler','Print Compiler',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_related_topic','Related Topic',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_reset_tracking','Reset tracker for new session.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_reset_tracking_desc','Empty your tracking data after each course session. You might choose to first archive data from previous sessions using the CSV tool above.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_resources','Resources',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_sequence','Sequence',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_session_start','Session Start',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_show_member_stats','Show member statistics',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_show_member_stats_desc','Understand how individual students are using your course, and provide them with content that will match their learning preferences.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_show_page_stats','Show page statistics',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_show_page_stats_desc','Review content and feature usage patterns as a source of information from which to improve the effectiveness of your course.',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_table_of_contents','Table of contents',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_tools','Tools',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_top_bypass','Top/#bypass anchor',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_to_sitemap','To sitemap',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_users_online','Users Online',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_view_thread','View Thread',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','g_within_sitemap','Within sitemap',NOW(),'course tracker');
INSERT INTO `lang_base` VALUES ('_template','head1','Head1',NOW(),'global code picker header link text');
INSERT INTO `lang_base` VALUES ('_template','head2','Head2',NOW(),'global code picker header link text');
INSERT INTO `lang_base` VALUES ('_template','header_editor','Header Editor',NOW(),'header editor heading');
INSERT INTO `lang_base` VALUES ('_template','hello','Hello',NOW(),'password reminder email message');
INSERT INTO `lang_base` VALUES ('_template','help','Help',NOW(),'global help label');
INSERT INTO `lang_base` VALUES ('_template','help_available','There is help available for this page',NOW(),'message appearing at bottom of help boxes');
INSERT INTO `lang_base` VALUES ('_template','help_forms','ATutor Help is available in various forms:',NOW(),'help/about_help');
INSERT INTO `lang_base` VALUES ('_template','help_open','Open Help for this screen.',NOW(),'help icons alt/title text');
INSERT INTO `lang_base` VALUES ('_template','help_preferences','<small>\r\n\r\n<p>Personal Preferences allow you to modify the look and layout of ATutor to your liking.   Edit your preferences on the <img src=\"images/prefs.gif\" alt=\"Preferences icon\" /> <a href=\"users/preferences.php?g=12\">Preferences</a> page. Each of the preference settings are described briefly in this section. </p>\r\n\r\n\r\n<h3>Position Options</h3>\r\n<p><b>Menu </b>: position the menu on the left or right. You might prefer it on the left if you are left handed, or you might prefer it on the right, because it\'s close to your browser\'s scroll bar.</p>\r\n\r\n<p><b>Sequence Links</b>: The sequence arrows (or text links) can be positioned at the top or bottom of the page, or both top and bottom.</p>\r\n\r\n<p><b>Table of Content</b>: Position the Contents menu either at the top of the content, or at the bottom. </p>\r\n\r\n\r\n<h3>Display Options</h3>\r\n\r\n<p><b>Show Topic Numbering</b>: Enabling this preference will display topics in the menus and page headings with accompanying numbers (e.g. 2.3.2). You might enable numbering if you prefer the content numerically structured, or disable numbering to conserve space or reduce the screen clutter.</p>\r\n\r\n<p><b>Show Breadcrumbs</b>: Hide breadcrumb links that appear across the top of the content area if you don\'t find them useful. Show breadcrumbs if you like to know your hierarchical  location in the content.</p>\r\n\r\n<p><b>Show Heading Navigation</b>: Show heading navigation to display page headings as links to other pages higher up in the hierarchy of the content you are viewing.  Hide heading navigation to conserve space, or if you do not find it useful.</p>\r\n\r\n<p><b>Show ATutor Help</b>: ATutor help boxes provide basic information for using ATutor tools.  Show ATutor Help while you are learning to use ATutor. Hide ATutor Help if you are familiar with ATutor. When ATutor Help is hidden, the Help icons remain.  Toggle the help icons to open and close the help box for the page you are viewing.</p>\r\n\r\n<p><b>Show ATutor Popup Help</b>: Popup help is available through a small question mark icon [<img src=\"images/help3.gif\" align=\"middle\" alt=\"mini help icon\" height=\"15\" width=\"16\" />] next to a tool, and provide tips on getting the most effective use out of the tool. Show popup help while are mastering the ATutor tools. Hide popup help when you have become an ATutor guru.</p>\r\n\r\n<h3>Text and Icons</h3>\r\n<p><b>Member Navigation</b>: Display the Member Navigation bar with  icons and text if you prefer a text and graphic representation in the main tabs across the top of ATutor. Display icons only to conserve space, reduce screen clutter, or to display only graphic representations. Display text only for accessibility, or if you prefer text over icons.</p>\r\n\r\n<p><b>Course Navigation</b>:  Display the Course Navigation bar with  icons and text if you prefer a text and graphic representation. Display icons only to conserve space, reduce screen clutter, or to display only graphic representations. Display text only for accessibility, or if you prefer text over icons.</p>\r\n\r\n<p><b>Sequence Navigation</b>:  Display the Sequence Navigation arrows with icons and text if you prefer a text and graphic representation. Display icons only to conserve space, reduce clutter, or to display only graphic representations. Display text only for accessibility, or if you prefer text over icons.</p>\r\n\r\n<p><b>Content Headings</b>:  Display the page headings with icons and text if you prefer a text and graphic representation. Display text only to conserve space, reduce clutter, or remove graphic representations. </p>\r\n\r\n<h3>Menu Options</h3>\r\n\r\n<p>Each of the menu modules that appear in the ATutor Menu are optional. You may choose to include all of the menu modules in your menu configuration, or you may choose not to display any of them. You may also choose to order the modules in the order that suits you.</p>\r\n\r\n<p>You might choose the display the <strong>Local Menu</strong>, and hide the <strong>Global Menu</strong> if you prefer  to see the content listing in a smaller, lesson size display. Or, you might choose to display the Global Menu and hide the Local Menu, if you prefer to see the content for the entire course listed.</p>\r\n\r\n<p>You might choose to locate the <strong>Users Online</strong> module at the top of the menu so you can easily see the list of classmates currently online, and communicate with them either through your Inbox and private messaging, or though the Chat.</p>\r\n\r\n<p>You might choose to locate the <strong>Related Topics </strong>module at the top of the menu so you can see a list of other topics in the course related to the current one.\r\n\r\n<h3>Themes</h3>\r\n\r\n<p>New in 1.4!  The overall look and feel of your ATutor installation is controlled by the theme setting.  ATutor comes with a default theme, but your system administrator can add other options.  </p>\r\n\r\n</small>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','help_preferences_text','Learn about the various display options available.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','hidden','Hidden',NOW(),'instructor/admin contact form');
INSERT INTO `lang_base` VALUES ('_template','hide_course','Hide this course from the Browse Courses list',NOW(),'create course screen');
INSERT INTO `lang_base` VALUES ('_template','history','History',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','hits','Hits',NOW(),'links database link hit count');
INSERT INTO `lang_base` VALUES ('_template','hit_count','Hit Count',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','home','Home',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','hot','Hot!',NOW(),'(not used)');
INSERT INTO `lang_base` VALUES ('_template','hot_thread','Hot very active thread!',NOW(),'forum message for busy thread');
INSERT INTO `lang_base` VALUES ('_template','hours_24','24hr',NOW(),'release date picker');
INSERT INTO `lang_base` VALUES ('_template','howto_course','HowTo Course',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','howto_course_text','The ATutor <em>HowTo</em> course contains the documentation for both students and instructors on using the ATutor system. The HowTo is available as a seperate download from <a href=\"http://atutor.ca\">ATutor.ca</a> and may already be available in the installation you are using. You may want to check if it\'s available through the <a href=\"users/browse.php\">course browser</a> and add it to your list of enrolled courses for quick access. It is also available via a link at the bottom of every page, which goes to the most current version hosted on the ATutor server.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','html','HTML',NOW(),'global HTML label');
INSERT INTO `lang_base` VALUES ('_template','html_disabled','HTML is disabled',NOW(),'inbox send message screen');
INSERT INTO `lang_base` VALUES ('_template','html_only',' Plain Text or HTML files only.',NOW(),'add/edit content, header');
INSERT INTO `lang_base` VALUES ('_template','icons_and_text','Icons and text',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','icons_only','Icons only',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','id','ID',NOW(),'global ID (identification number) label');
INSERT INTO `lang_base` VALUES ('_template','id_ascending','Order by ID Ascending',NOW(),'admin user/course manager');
INSERT INTO `lang_base` VALUES ('_template','id_descending','Order by ID Descending',NOW(),'admin user/course manager');
INSERT INTO `lang_base` VALUES ('_template','illegal_file','Illegal File Type',NOW(),'zip utility when archive contain illegal extension');
INSERT INTO `lang_base` VALUES ('_template','image','Image',NOW(),'global code picker image code link text');
INSERT INTO `lang_base` VALUES ('_template','import','Import',NOW(),'instructor import/export screen');
INSERT INTO `lang_base` VALUES ('_template','import_about','You can import files created by the Export tool below. (NOTE: Courses may take some time to import, depending on the course size and your Internet connection speed. Please be patient.)',NOW(),'instructor import/export screen');
INSERT INTO `lang_base` VALUES ('_template','import_a_new_lang','Import a New Language',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','import_content_package','Import Content Package',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_content_package_about','You may import a content package that has been exported from another ATutor course or a standards compliant application. The package can be imported at the end of this course or as subcontent of an existing page.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_content_package_bottom_subcontent','As top level content, or as subcontent selected below',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_content_package_where','Import into',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_course','Import Course Material',NOW(),'instructor import/export screen');
INSERT INTO `lang_base` VALUES ('_template','import_course_list','Import Course List',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_course_list_verify','The following accounts were found. If there are errors, either fix them or check the \"Remove\" box to not include the record in the enroll listing.  Use the \"Resubmit\" button to submit your changes. When there are no errors, use the \"Import Course List\" button to proceed in making the new user accounts, and enrolling each student in this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_err_email_exists','Account exists.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_err_email_invalid','Email invalid.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_err_email_missing','Email missing.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_err_username_exists','Username already taken.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_err_username_invalid','Username contains invalid characters.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','import_export','Content Packaging',NOW(),'instructor control centre course properties link text');
INSERT INTO `lang_base` VALUES ('_template','import_file','Import File',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','import_into','Importing into',NOW(),'context(?)');
INSERT INTO `lang_base` VALUES ('_template','import_lang_howto','After downloading a new language from the ATutor.ca Web site, use the browse button to locate it in your computer\'s file system, then press \"Import\" to upload and install it into ATutor.  (NOTE: Language files may take some time to import, depending on your Internet connection speed, and the processing power of your Web server. Please be patient.)',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','import_sep_txt','For auto-generated usernames, separate first and last names with:',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ims_exporting','Exporting IMS Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','ims_export_about','The ATutor IMS Packaging tool will send you a single archived file containing all of your course content.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','inbox','Inbox',NOW(),'global Inbox label');
INSERT INTO `lang_base` VALUES ('_template','inbox_about','Send a private message to another member. <a href=\"inbox.php\">Your Inbox</a>.',NOW(),'inbox screen');
INSERT INTO `lang_base` VALUES ('_template','inbox_date_format','%%l %%M %%j, %%Y - %%H:%%i',NOW(),'inbox screen (see www.php.net/date for codes)');
INSERT INTO `lang_base` VALUES ('_template','inbox_text','Send and receive private messages. Communicate with individual course members.',NOW(),'discussions');
INSERT INTO `lang_base` VALUES ('_template','infinite','Infinite',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','info','Info',NOW(),'global info message box label');
INSERT INTO `lang_base` VALUES ('_template','insert','Insert',NOW(),'instructor add content screen');
INSERT INTO `lang_base` VALUES ('_template','insert_code','Insert Code',NOW(),'Code Picker');
INSERT INTO `lang_base` VALUES ('_template','instructor','Instructor',NOW(),'global instructor label');
INSERT INTO `lang_base` VALUES ('_template','instructors','Instructors',NOW(),'admin general statistics label for number of instructors');
INSERT INTO `lang_base` VALUES ('_template','instructor_ascending','Order by Instructor Ascending',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','instructor_contact','Course Instructor Contact Form',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','instructor_contact_form','Instructor Contact Form',NOW(),'instructor contact form heading');
INSERT INTO `lang_base` VALUES ('_template','instructor_descending','Order by Instructor Descending',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','instructor_information','Instructor Information',NOW(),'heading for admin course properties');
INSERT INTO `lang_base` VALUES ('_template','instructor_request','ATutor Instructor Request',NOW(),'subject line in email to admin when instructor request is made');
INSERT INTO `lang_base` VALUES ('_template','instructor_requests','Instructor Requests',NOW(),'admin home page heading');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_deny','Your ATutor instructor request has been denied.',NOW(),'email message to denied instructor');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_denymsg1','Registration information is incomplete.',NOW(),'reason why denied');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_denymsg2','Inappropriate subject matter.',NOW(),'reason why denied');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_denymsg3','The course description requires more detail.',NOW(),'deny instructor request');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_denymsg4','You have requested enrollment with the wrong form.',NOW(),'admin deny instructor request');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_enterdenymsg','Choose a message explaining why the user\'s request was denied or enter your own.',NOW(),'Header text for deny message text area');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_msg','Your instructor account request for the ATutor system has been approved. Go to %s to login to your control centre and start creating your courses.',NOW(),'email messsage sent to instructor when instructor status is updates');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_msg1','Your instructor account request for the ATutor system has been approved. Go to',NOW(),'context (old 1.1)');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_msg2','to login to your control centre and start creating your courses.',NOW(),'context (old 1.1)');
INSERT INTO `lang_base` VALUES ('_template','instructor_request_reply','Your ATutor instructor request has been approved. Go to %s to login to your Control Centre, then select \"Create a New Course\".',NOW(),'email message to approved instructor');
INSERT INTO `lang_base` VALUES ('_template','instructor_tools','Instructor Tools',NOW(),'instructor tools page heading');
INSERT INTO `lang_base` VALUES ('_template','invalid_session','Not a Valid Session',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','in_reply_to','In reply to',NOW(),'replyto label for quoted forum or inbox message');
INSERT INTO `lang_base` VALUES ('_template','italic','Italic',NOW(),'global code picker link text');
INSERT INTO `lang_base` VALUES ('_template','jump','Jump',NOW(),'jump menu submit button text');
INSERT INTO `lang_base` VALUES ('_template','jump_code','Jump over the code picker',NOW(),'alt text for bypass link to jump over the code picker');
INSERT INTO `lang_base` VALUES ('_template','jump_codes','Jump over the code picker',NOW(),'alt text for bypass link to jump over the code picker');
INSERT INTO `lang_base` VALUES ('_template','keep_it_short','Tip: Keep it short, no spaces.',NOW(),'file manager suggestion for folder creation');
INSERT INTO `lang_base` VALUES ('_template','keywords','Keywords',NOW(),'content add/edit');
INSERT INTO `lang_base` VALUES ('_template','kilobytes','Kilobytes',NOW(),'file size');
INSERT INTO `lang_base` VALUES ('_template','langs_on_this_system','The following languages are available on this ATutor system:',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','language','Language',NOW(),'profile, registration');
INSERT INTO `lang_base` VALUES ('_template','lang_manager','ATutor Language Manager',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','last_comment','Last Comment',NOW(),'forums, thread view column label');
INSERT INTO `lang_base` VALUES ('_template','last_modified','Last Modified',NOW(),'instructor content editor link text');
INSERT INTO `lang_base` VALUES ('_template','last_name','Last Name',NOW(),'registration, profile, admin user manager');
INSERT INTO `lang_base` VALUES ('_template','last_name_ascending','Order by Last Name Ascending',NOW(),'admin user manager column heading');
INSERT INTO `lang_base` VALUES ('_template','last_name_descending','Order by Last Name Descending',NOW(),'admin user manager column heading');
INSERT INTO `lang_base` VALUES ('_template','last_post','Last Post',NOW(),'Refers to date of last post in forum');
INSERT INTO `lang_base` VALUES ('_template','lc_discussion_text','The Discussion icon is placed near topics that might be interesting, controversial, raise questions, or challenge your way of thinking. Use the topic to start a discussion thread.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_discussion_title','Discussion',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_dont_text','This icon is present when bad habits are being discussed, or something that should be avoided has been mentioned.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_dont_title','Don\'t!',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_do_text','Dos are the opposite of Don\'ts. Dos are things you should try to make habit, or things you should seek out and practice.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_do_title','Do!',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_important_text','This icon signifies information that shouldn\'t be missed. If you are breezing through the course looking for activities, you might want to stop here and read a little. If you are going to learn anything from the course you should learn this.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_important_title','Important',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lc_information_text','The Information icon is found near information not directly related to the course content but helpful in ways that can assist your learning. This information might be a \"how to..\" page, a link to technical information, an address or phone number, a reference to a topic outside the focus of the course, or just something interesting.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_information_title','Information',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_link_text','This linked Addlinks icon can be found often throughout the course. It will take you to a page with a collection of links that have been added to the site by other participants. If you find an interesting site you think might fit into the course resources, please take a minute and add it to the Addlinks page. Also refer to the Addlinks page for the most recent updates. These new resources are used to replace broken links on other resource pages that need replacing each session. You can help keep the course resources up to date by adding two or three new links yourself.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_link_title','Links Database',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_listen_text','The Listen icon means a streamed audio transcript of the page is available. Introductory pages and instructions often include audio. Real audio player is required.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_listen_title','Listen',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_project_text','This icon is placed near interesting topics that would be ideal for a short project. Those who intend to do a course project may want to scan the course site for these icons before deciding on a topic.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_project_title','A Project Topic',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_question_text','The Question mark asks you to question the truth or validity of a statement or theory. Ask yourself \"Is this really true?\" Why do you think it isn\'t true? Why do you think someone else thinks it is?',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_question_title','Question This',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_read_text','This icon signifies additional reading or a more advanced look at a topic. This reading may include a relevant paper published on the Web, a recommended book or paper reference, or more advanced course notes. Those who would rather do activies and forego the reading, can skip over items marked with these icons.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_read_title','Read',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_test_text','The test icon appears beside paragraphs or list items that refer to an ability that can be tested. These little tests are often quick activities that will make you aware of a particular type of thinking. Others test your endurance with thinking activities, some challenge the limits of your ability, and others are just for fun. Sometimes tests are just tests, seeing what you recall from what you\'ve been learning.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lc_test_title','A Test',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_think_text','This icon signifies \"deep\" thought. You may argue to support or oppose a position being taken, justify a comment based on the logic of an argument, find evidence from other sources to clarify uncertainty, or perhaps add to an argument to extend its logic into other domains.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_think_title','Think Critically',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_write_text','The Write icon signifies some form of writing. It may mean a pencil and paper should be used, it may mean make a note of this, it may mean rewrite this in your own words to better understand, or it may mean try writing about the topic, perhaps a page or two from memory.',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','lc_write_title','Write',NOW(),'learning concept');
INSERT INTO `lang_base` VALUES ('_template','leave_blank','Leave blank',NOW(),'mytest/test manager question option');
INSERT INTO `lang_base` VALUES ('_template','left','Left',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','left_blank','Left blank',NOW(),'mytests/test manager question result text for unanswerd question');
INSERT INTO `lang_base` VALUES ('_template','legend','Legend',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','link','Link',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','links_database','Links Database',NOW(),'links database heading');
INSERT INTO `lang_base` VALUES ('_template','links_database_text','Search though course related links, add your course related link.',NOW(),'resources');
INSERT INTO `lang_base` VALUES ('_template','links_db','Links Database',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','links_pending','( # approved / # non-approved ) links.',NOW(),'link database');
INSERT INTO `lang_base` VALUES ('_template','links_windows','Links open in a new window.',NOW(),'links');
INSERT INTO `lang_base` VALUES ('_template','link_auto_approved','This link was auto-approved.',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','link_disapproved','Link Disapproved',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','link_needs_approval','This link needs approval',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','list_creating_new_user','Creating new member %s for %s %s.<br />',NOW(),'import course list results');
INSERT INTO `lang_base` VALUES ('_template','list_email_exists','Email address %s exists. Using existing information for %s %s .<br />',NOW(),'import course list results');
INSERT INTO `lang_base` VALUES ('_template','list_export_course_list','Export Course List',NOW(),'enrol admin');
INSERT INTO `lang_base` VALUES ('_template','list_import_course_list','Import Course List',NOW(),'import course list');
INSERT INTO `lang_base` VALUES ('_template','list_import_howto','A course enrollment list may be imported into ATutor. Create the course list in a comma separated values (CSV) format as follows: <code>\"firstname\", \"lastname\", \"email\"</code> with one student per line.  New students will receive their access instructions by email.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','list_import_results','Results of Course List Import',NOW(),'course list import');
INSERT INTO `lang_base` VALUES ('_template','list_member_already_enrolled','%s is already enrolled in this course.<br />',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','list_member_already_exists','New member was not created. Using existing member information.<br />',NOW(),'import course list results');
INSERT INTO `lang_base` VALUES ('_template','list_member_enrolled','%s added to course enrollment.<br />',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','list_new_member_created','New member %s successfully created. <br />',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','list_return_to_enrollment','Return to Course Enrollment',NOW(),'import course list');
INSERT INTO `lang_base` VALUES ('_template','lk_agree','Agree',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_always','Always',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_disagree','Disagree',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_excellent','Excellent',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_fair','Fair',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_good','Good',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_important','Important',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_little_importance','Of Little Importance',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_mod_important','Moderately Important',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_never','Never',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_occasionally','Occasionally',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_poor','Poor',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_rarely','Rarely',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_strongly_agree','Strongly Agree',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_strongly_disagree','Strongly Disagree',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_undecided','Undecided',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_unimportant','Unimportant',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_very_frequently','Very Frequently',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_very_good','Very Good',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_very_important','Very Important',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_very_poor','Very Poor',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','lk_very_rarely','Very Rarely',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','load_default_css','Load ATutor Default Stylesheet',NOW(),'instructor stylesheet editor');
INSERT INTO `lang_base` VALUES ('_template','load_left','Load Default Left Wrap-around Template.',NOW(),'header editor');
INSERT INTO `lang_base` VALUES ('_template','load_right','Load Default Right Wrap-around Template.',NOW(),'header editor');
INSERT INTO `lang_base` VALUES ('_template','local_menu','Local Menu',NOW(),'context  (?)');
INSERT INTO `lang_base` VALUES ('_template','lock_no_post','No posting, but allow reading.',NOW(),'forum instructor lock text');
INSERT INTO `lang_base` VALUES ('_template','lock_no_post1','This thread is locked from posting.',NOW(),'forum instructor lock text');
INSERT INTO `lang_base` VALUES ('_template','lock_no_read','No posting and no reading.',NOW(),'context');
INSERT INTO `lang_base` VALUES ('_template','lock_no_read1','This thread is locked from reading and posting.',NOW(),'forum thread display lock message');
INSERT INTO `lang_base` VALUES ('_template','lock_submit','Apply Lock',NOW(),'text for instructor forum lock button');
INSERT INTO `lang_base` VALUES ('_template','lock_thread','Lock Thread',NOW(),'Alt text for forum instructor lock icon');
INSERT INTO `lang_base` VALUES ('_template','lock_type','Select type of lock',NOW(),'forum instructor lock screen');
INSERT INTO `lang_base` VALUES ('_template','logged_in_as','Logged in as',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','login','Login',NOW(),'global login label');
INSERT INTO `lang_base` VALUES ('_template','logins','Logins',NOW(),'instructor control centre login stats lable');
INSERT INTO `lang_base` VALUES ('_template','login_id','Login (ID)',NOW(),'instructor enrolments manager column heading');
INSERT INTO `lang_base` VALUES ('_template','login_into_atutor','Log into your ATutor Account',NOW(),'login after enrollment message');
INSERT INTO `lang_base` VALUES ('_template','login_name','Login Name',NOW(),'control centre account information label');
INSERT INTO `lang_base` VALUES ('_template','login_nav','Login Navigation',NOW(),'preferences option');
INSERT INTO `lang_base` VALUES ('_template','login_statistics','%s login statistics for  %s',NOW(),'course login details');
INSERT INTO `lang_base` VALUES ('_template','logout','Log-out',NOW(),'global logout link text');
INSERT INTO `lang_base` VALUES ('_template','main_nav','Main Navigation',NOW(),'preferences option');
INSERT INTO `lang_base` VALUES ('_template','male','Male',NOW(),'registration, profile, admin user manager');
INSERT INTO `lang_base` VALUES ('_template','mark','Mark',NOW(),'mytests/test manager');
INSERT INTO `lang_base` VALUES ('_template','marking','Marking',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','marks','marks',NOW(),'mytests/test manager');
INSERT INTO `lang_base` VALUES ('_template','marks_unavailable','This test/survey does not get marked.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','mark_instructor','Manually by instructor or assistant',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','mark_statistics','Submission Statistics',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','max','Max',NOW(),'admin course manager course properties size quota');
INSERT INTO `lang_base` VALUES ('_template','maximum','Maximum',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','max_file_size','Max File Size',NOW(),'admin course manager properties');
INSERT INTO `lang_base` VALUES ('_template','max_file_size_system','Maximum system allows',NOW(),'php\'s max file size');
INSERT INTO `lang_base` VALUES ('_template','megabytes','Megabytes',NOW(),'file size for course properties');
INSERT INTO `lang_base` VALUES ('_template','members','Members',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','member_id','Member ID',NOW(),'admin user manager column heading');
INSERT INTO `lang_base` VALUES ('_template','member_navigation','Member Navigation',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','menu','Menu',NOW(),'preferences option');
INSERT INTO `lang_base` VALUES ('_template','menus','Menus',NOW(),'preferences option');
INSERT INTO `lang_base` VALUES ('_template','menu_menu','Global Menu',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','message','Message',NOW(),'inbox send message screen');
INSERT INTO `lang_base` VALUES ('_template','message_sent','<b>Your message has been sent. <a href=\"help/\">Help home</a>.</b>',NOW(),'message after sending a message to and instructor or administrator through the contact formss');
INSERT INTO `lang_base` VALUES ('_template','minimum','Minimum',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','modify_existing_lang','Modify Language',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','modify_lang_howto','Select from the languages available on this system using the menu below, then \"Set\" that language to modify it. Click on \"<strong>Template</strong>\" to display the ATutor interface language variables. Click on \"<strong>Msgs</strong>\" to display feedback, warning, and error message variables. Click on a variable to display its language.',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','month','Month',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','move','Move',NOW(),'editing content');
INSERT INTO `lang_base` VALUES ('_template','move_to','Move To',NOW(),'instructor content editor');
INSERT INTO `lang_base` VALUES ('_template','move_to_category','To suggest a new link you must first be in the appropriate category',NOW(),'message to users adding new links to the links database');
INSERT INTO `lang_base` VALUES ('_template','multi_page_test','One question per page.',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','my_control_centre','My Control Centre',NOW(),'jump menu text for control center option');
INSERT INTO `lang_base` VALUES ('_template','my_courses','My Courses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','my_enrolled_courses','My enrolled courses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','my_tests','My Tests &amp; Surveys',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','my_tests_text','Take course tests or surveys here and review your results.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','my_tracker','My Tracker',NOW(),'global my tracker  heading');
INSERT INTO `lang_base` VALUES ('_template','my_tracker_text','Review your navigation tendencies and click path.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','na','N/A',NOW(),'short form for \"not applicable\"');
INSERT INTO `lang_base` VALUES ('_template','name','Name',NOW(),'file manager, zip utility column heading');
INSERT INTO `lang_base` VALUES ('_template','nav_path','Navigation Path for User',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','nav_tendencies','Navigation Tendencies for User',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','neither','Neither',NOW(),'TOC preference');
INSERT INTO `lang_base` VALUES ('_template','new','New!',NOW(),'forum/inbox new message indicator');
INSERT INTO `lang_base` VALUES ('_template','newest_links','Newest Links',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','new_account_msg','A user account has been created for you.  Please visit the address below to login:\r\n%s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','new_category','New Category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','new_cat_suggested','A new category was suggested for this link',NOW(),'message to instructor when a new category is suggested');
INSERT INTO `lang_base` VALUES ('_template','new_forum','New Forum',NOW(),'instructor discussions screen');
INSERT INTO `lang_base` VALUES ('_template','new_link','New Link',NOW(),'subjest line of email to instructor after a new link is suggested in the links database');
INSERT INTO `lang_base` VALUES ('_template','new_links','Newest Links',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','new_lk_question','New Likert Question',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','new_mc_question','New Multiple Choice Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','new_message','New Message',NOW(),'inbox');
INSERT INTO `lang_base` VALUES ('_template','new_open_question','New  Open Ended Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','new_test','New Test/Survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','new_tf_question','New True or False Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','new_thread','New Thread',NOW(),'forum');
INSERT INTO `lang_base` VALUES ('_template','next','Next',NOW(),'sequence arrow link text');
INSERT INTO `lang_base` VALUES ('_template','next_none','Next:  None',NOW(),'sequence arrow link text');
INSERT INTO `lang_base` VALUES ('_template','next_topic','Next Topic',NOW(),'sequence arrow link text');
INSERT INTO `lang_base` VALUES ('_template','no','no',NOW(),'the word no, preferences, admin course manager');
INSERT INTO `lang_base` VALUES ('_template','no1','No',NOW(),'enrol admin');
INSERT INTO `lang_base` VALUES ('_template','none','None',NOW(),'global message when no results were retrieved');
INSERT INTO `lang_base` VALUES ('_template','none_available','None available.',NOW(),'instructor add/edit content, glossary');
INSERT INTO `lang_base` VALUES ('_template','none_found','None Found',NOW(),'glossary, related topis, users online');
INSERT INTO `lang_base` VALUES ('_template','notes','Notes',NOW(),'admin hime, instructor request notes column heading');
INSERT INTO `lang_base` VALUES ('_template','notify','Notify',NOW(),'admin course properties');
INSERT INTO `lang_base` VALUES ('_template','not_authorized','Not authorized',NOW(),'link database message when link submitted without authorization');
INSERT INTO `lang_base` VALUES ('_template','not_markable','Does not get marked',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','not_specified','Not specified',NOW(),'registration gender selection');
INSERT INTO `lang_base` VALUES ('_template','not_teacher','You do not teach any courses.',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','not_your_course','This is not your course.',NOW(),'delete course when not owned by user');
INSERT INTO `lang_base` VALUES ('_template','no_account','Not yet registered?',NOW(),'login screen');
INSERT INTO `lang_base` VALUES ('_template','no_announcements','No Announcements Found',NOW(),'course homepage when no announcments exist');
INSERT INTO `lang_base` VALUES ('_template','no_cancel','No / Cancel',NOW(),'global delete functions cancel operation');
INSERT INTO `lang_base` VALUES ('_template','no_cats','Category: Uncategorized - no categories available',NOW(),'Course Properties');
INSERT INTO `lang_base` VALUES ('_template','no_change','No Change',NOW(),'instructor content editor move tool');
INSERT INTO `lang_base` VALUES ('_template','no_courses','There are no available courses.',NOW(),'browse message when no courses exist');
INSERT INTO `lang_base` VALUES ('_template','no_courses_found','No courses found.',NOW(),'message when query resuylt in no courses found, admin course manager');
INSERT INTO `lang_base` VALUES ('_template','no_course_found','Course not found.',NOW(),'course not found');
INSERT INTO `lang_base` VALUES ('_template','no_description','No description available.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','no_enrolments','You are not enrolled in any courses. Use the <a href=\"users/browse.php\">Course Browser</a> to find and enroll in courses.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','no_forums','No Forums Found',NOW(),'discussions message when no forums exist');
INSERT INTO `lang_base` VALUES ('_template','no_glossary_items','No glossary items found.',NOW(),'edit glossary');
INSERT INTO `lang_base` VALUES ('_template','no_links','No links found.',NOW(),'link database message when no links exist');
INSERT INTO `lang_base` VALUES ('_template','no_matches','No Matches',NOW(),'links database message when search return no results');
INSERT INTO `lang_base` VALUES ('_template','no_month_data','There is no data for this month.',NOW(),'instructor course statistics when nonne exist');
INSERT INTO `lang_base` VALUES ('_template','no_pages_found','No pages found',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','no_polls_found','No polls found.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','no_post','No post found.',NOW(),'forums message when attempting to view a post that no longer exists');
INSERT INTO `lang_base` VALUES ('_template','no_presets','No Presets Found.',NOW(),'preferences message text when no preset preferences exist');
INSERT INTO `lang_base` VALUES ('_template','no_questions','No questions found.',NOW(),'test manager message when no questions exist for a test.');
INSERT INTO `lang_base` VALUES ('_template','no_questions_avail','No questions available.',NOW(),'mytests messages when test has no questions');
INSERT INTO `lang_base` VALUES ('_template','no_results_available','No Results Available',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','no_results_yet','No Results Yet',NOW(),'my tests');
INSERT INTO `lang_base` VALUES ('_template','no_terms_found','There are no glossary terms being used in this content page.',NOW(),'content editor');
INSERT INTO `lang_base` VALUES ('_template','no_tests','No Tests or Surveys Available',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','no_unmarked_results','No unmarked test results found.',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','no_users_found_for','No users found for letter',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','no_user_found','No user found',NOW(),'admin user amanager, profile');
INSERT INTO `lang_base` VALUES ('_template','num','No.',NOW(),'short form for the word number, test manager');
INSERT INTO `lang_base` VALUES ('_template','num_questions_per_test','questions per test.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','num_takes_test','Attempts Allowed',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','off','off',NOW(),'admin course manager properties tracking option');
INSERT INTO `lang_base` VALUES ('_template','ok','OK',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','on','on',NOW(),'admin course manager properties tracking option');
INSERT INTO `lang_base` VALUES ('_template','one_page','One Page',NOW(),'test manager open ended question type');
INSERT INTO `lang_base` VALUES ('_template','one_page_test','All on one page.',NOW(),'test manager open ended question type');
INSERT INTO `lang_base` VALUES ('_template','one_sentence','One Sentence',NOW(),'test manager open ended question type');
INSERT INTO `lang_base` VALUES ('_template','one_word','One Word',NOW(),'test manager open ended question type');
INSERT INTO `lang_base` VALUES ('_template','ongoing','On Going!',NOW(),'mytest currently running test indicator');
INSERT INTO `lang_base` VALUES ('_template','open_frame','Open File Manager Frame',NOW(),'instructor edit content screen');
INSERT INTO `lang_base` VALUES ('_template','open_global_menu','Open Global Menu',NOW(),'global menu label');
INSERT INTO `lang_base` VALUES ('_template','open_glossary_terms','Open Glossary Terms',NOW(),'glossary menu link text');
INSERT INTO `lang_base` VALUES ('_template','open_help','Help - opens in a new window',NOW(),'alt text for mini help icons');
INSERT INTO `lang_base` VALUES ('_template','open_local_menu','Open Local Menu',NOW(),'local menu link text');
INSERT INTO `lang_base` VALUES ('_template','open_menus','Open Menus',NOW(),'Menus link text');
INSERT INTO `lang_base` VALUES ('_template','open_poll','Open Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','open_related_topics','Open Related Topics',NOW(),'related topic menu link text');
INSERT INTO `lang_base` VALUES ('_template','open_search','Open Search',NOW(),'search menu');
INSERT INTO `lang_base` VALUES ('_template','open_users_online','Open Users Online',NOW(),'users online menu link text');
INSERT INTO `lang_base` VALUES ('_template','optional','Optional',NOW(),'registration screen');
INSERT INTO `lang_base` VALUES ('_template','or','Or',NOW(),'global word or');
INSERT INTO `lang_base` VALUES ('_template','orange','Orange',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','origin_page','Originating Page',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','Other','Other',NOW(),'admin course information, file size');
INSERT INTO `lang_base` VALUES ('_template','others','Others',NOW(),'glossary alphabet list');
INSERT INTO `lang_base` VALUES ('_template','out_of','Out of',NOW(),'mytests, score out of ...');
INSERT INTO `lang_base` VALUES ('_template','override','Override selections with this course\\\'s custom Colour & Font theme.  <small class=\"spacer\">( If available. )</small>',NOW(),'preferences page');
INSERT INTO `lang_base` VALUES ('_template','overwite_content','Overwrite existing content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','packaged_in','Content Package',NOW(),'apckage label in edit content');
INSERT INTO `lang_base` VALUES ('_template','page','Page',NOW(),'forum thread pages menu, tracker pages menu');
INSERT INTO `lang_base` VALUES ('_template','pages_found','%s pages found',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','pages_stats','Page Tracking Statistics for %s.',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','page_error','An error occured while generating the paginator',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','page_info','Last Modified: %s.  Revision: %s.  Release Date: %s.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','page_stats','Content Tracking Summary',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','page_title','Page Title',NOW(),'tracker column heading');
INSERT INTO `lang_base` VALUES ('_template','page_viewed','Page Viewed',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','password','Password',NOW(),'global password word');
INSERT INTO `lang_base` VALUES ('_template','password_again','Password Again',NOW(),'registration, edit profile');
INSERT INTO `lang_base` VALUES ('_template','password_blurb','Enter your email address below and your login and password will be sent to you. The email address must be the same as the one you used for <a href=\"registration.php\">registration</a>.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','password_reminder','Password Reminder',NOW(),'password reminder screen heading, public login header');
INSERT INTO `lang_base` VALUES ('_template','password_request2','The login and password information is listed directly below:',NOW(),'password reminder');
INSERT INTO `lang_base` VALUES ('_template','password_success','Your login and password have been successfully emailed.',NOW(),'password reminder');
INSERT INTO `lang_base` VALUES ('_template','paste_file','Paste From File',NOW(),'instructor content editor');
INSERT INTO `lang_base` VALUES ('_template','pending','Pending',NOW(),'mytests, control centre');
INSERT INTO `lang_base` VALUES ('_template','pending_approval','(pending approval)',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','pending_approval2','<strong><em>pending',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','pending_approval3','approval </em></strong>',NOW(),'control centre');
INSERT INTO `lang_base` VALUES ('_template','period','Period',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','personal_bar','Personal Bar',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','personal_information','Personal Information',NOW(),'registration, profile edit');
INSERT INTO `lang_base` VALUES ('_template','personal_preferences','Personal Preferences',NOW(),'preferences screen heading');
INSERT INTO `lang_base` VALUES ('_template','per_day','per day',NOW(),'instructor course statistics, details');
INSERT INTO `lang_base` VALUES ('_template','phone','Area Code and Phone Number',NOW(),'global phone number field label');
INSERT INTO `lang_base` VALUES ('_template','plain_text','plain text',NOW(),'instructor content editor, news, inbox, forum message format');
INSERT INTO `lang_base` VALUES ('_template','poll','Poll',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','polls','Polls',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','polls_text','Create and edit polls for this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','poll_text','Create and edit polls for this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','post','Post',NOW(),'forum new thread post button');
INSERT INTO `lang_base` VALUES ('_template','postal_code','Postal/Zip Code',NOW(),'global postal code filed labal');
INSERT INTO `lang_base` VALUES ('_template','posted','Posted',NOW(),'announcements post date');
INSERT INTO `lang_base` VALUES ('_template','posted_by','By',NOW(),'forum message submitter');
INSERT INTO `lang_base` VALUES ('_template','posted_on','on',NOW(),'forum message post date, inbox');
INSERT INTO `lang_base` VALUES ('_template','posts','Posts',NOW(),'Header for posts in Forum List');
INSERT INTO `lang_base` VALUES ('_template','post_lock','Locked from posting',NOW(),'forum lock thread message');
INSERT INTO `lang_base` VALUES ('_template','pos_options','Position Options',NOW(),'preferences option heading');
INSERT INTO `lang_base` VALUES ('_template','preferences','Preferences',NOW(),'global preferences word');
INSERT INTO `lang_base` VALUES ('_template','preferences_text','Modify the appearance and layout of ATutor.',NOW(),'tools');
INSERT INTO `lang_base` VALUES ('_template','presets','Presets',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','preset_preferences','Preset Preferences',NOW(),'preferences preset heading');
INSERT INTO `lang_base` VALUES ('_template','preset_scales','Preset &amp; Previously Used Scales',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','preview','Preview',NOW(),'test manager preview test');
INSERT INTO `lang_base` VALUES ('_template','preview_of','Preview of',NOW(),'test manager preview screen');
INSERT INTO `lang_base` VALUES ('_template','preview_test','Preview this test.',NOW(),'test manager preview test link text');
INSERT INTO `lang_base` VALUES ('_template','previous','Previous',NOW(),'global sequence arrow alt/link text');
INSERT INTO `lang_base` VALUES ('_template','previous_none','Previous: None',NOW(),'global sequence arrow alt/link text');
INSERT INTO `lang_base` VALUES ('_template','previous_topic','Previous Topic',NOW(),'global sequence arrow alt/link text');
INSERT INTO `lang_base` VALUES ('_template','prev_used','Previously Used',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','primary_language','Primary Language',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','private','Private',NOW(),'global private course indicator');
INSERT INTO `lang_base` VALUES ('_template','privileges','Privileges',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_ac_access_all','<strong>ACollab:</strong> Access all groups',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_ac_create','<strong>ACollab:</strong> Create Groups',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_announcements','Announcements',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_content','Content',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_course_email','Course Email',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_enrollment','Enrollment',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_files','File Manager',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_forums','Forums & Chat',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_glossary','Glossary',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_links','Web Links',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_polls','Polls',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_styles','Layout &amp; Styles',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_test_create','Test Creation',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','priv_test_mark','Test Marking',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','profile','Profile',NOW(),'control centre heading');
INSERT INTO `lang_base` VALUES ('_template','profile_back_to_enrollment','Back to Enrollment',NOW(),'view profile');
INSERT INTO `lang_base` VALUES ('_template','profile_for','Profile for',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','profile_student_information','Student Information',NOW(),'view profile');
INSERT INTO `lang_base` VALUES ('_template','properties','Properties',NOW(),'instructor control centre');
INSERT INTO `lang_base` VALUES ('_template','protected','Protected',NOW(),'browse, create coruse, control centre, course properties');
INSERT INTO `lang_base` VALUES ('_template','province','Province/State',NOW(),'registration, profile editor');
INSERT INTO `lang_base` VALUES ('_template','public','Public',NOW(),'browse courses, create course, course properties, control centre');
INSERT INTO `lang_base` VALUES ('_template','purple','Purple',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','question','Question',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','questions','Questions',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','questions_for','Questions for',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','question_statistics','Question Statistics',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','quote','Quote',NOW(),'code picker alt text');
INSERT INTO `lang_base` VALUES ('_template','randomize_questions','Randomize Questions',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','raw','Raw',NOW(),'course tracker member picker');
INSERT INTO `lang_base` VALUES ('_template','raw_data','Raw Data',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','read_lock','Locked from posting & reading',NOW(),'forum lock message in thread list');
INSERT INTO `lang_base` VALUES ('_template','real_name','Real Name',NOW(),'course properties');
INSERT INTO `lang_base` VALUES ('_template','red','Red',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','red_members','Red = Members',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','register','Register',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','register_an_account','Register an ATutor System Account',NOW(),'private course enrolment screen, login screen');
INSERT INTO `lang_base` VALUES ('_template','registration','Registration',NOW(),'registration page header');
INSERT INTO `lang_base` VALUES ('_template','related_to','Related To',NOW(),'instructor add/edit content screens');
INSERT INTO `lang_base` VALUES ('_template','related_topics','Related Topics',NOW(),'context(?)');
INSERT INTO `lang_base` VALUES ('_template','release_date','Release Date',NOW(),'instructor add/edit content, control centre');
INSERT INTO `lang_base` VALUES ('_template','remove','Remove',NOW(),'control centre, admin user manager, instructor enrolment manager');
INSERT INTO `lang_base` VALUES ('_template','removed','Removed',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','rename','Rename',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','rename_file_dir','Rename File or Directory',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','replied','Replied',NOW(),'inbox message status label');
INSERT INTO `lang_base` VALUES ('_template','replies','Replies',NOW(),'forum');
INSERT INTO `lang_base` VALUES ('_template','reply','Reply',NOW(),'forum, inbox');
INSERT INTO `lang_base` VALUES ('_template','replyto','Reply To',NOW(),'context (?)');
INSERT INTO `lang_base` VALUES ('_template','request_date','Request Date',NOW(),'admin home page instructor requests table');
INSERT INTO `lang_base` VALUES ('_template','request_enrollment','Request Enrollment',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','request_enrolment','Request Enrolment',NOW(),'enrol page button text');
INSERT INTO `lang_base` VALUES ('_template','request_instructor_account','Request Instructor Account',NOW(),'control centre non-instructor');
INSERT INTO `lang_base` VALUES ('_template','request_instructor_disabled','(Instructor requests are not permitted)',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','required','Required',NOW(),'registration, export course, test manager question editor');
INSERT INTO `lang_base` VALUES ('_template','req_message1','ATutor System Admin,',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message2','A new Instructor account request has been made.',NOW(),'context (removed after V1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message3','has been made.',NOW(),'context (old 1.1) combined with req_message2');
INSERT INTO `lang_base` VALUES ('_template','req_message4','Course Description:',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message5','You must login to your Control Centre at',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message6','about.php then manually add /admin.php to the end of the URL. (The URL will then be',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message7','users/admin.php.)',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message8','login: admin\r\npassword: [the Admin password you chose in the config.inc.php file]',NOW(),'context (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','req_message9','ATutor Instructor Request',NOW(),'email message subject line from control centre instructor request');
INSERT INTO `lang_base` VALUES ('_template','req_message_instructor','A new Instructor account request has been made by: %s.\r\n\r\nCourse Description: %s\r\n\r\nYou must login as the administrator at %s to approve or reject this request.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','reset','Reset',NOW(),'global text for reset buttons');
INSERT INTO `lang_base` VALUES ('_template','resources','Resources',NOW(),'global resources link text');
INSERT INTO `lang_base` VALUES ('_template','resource_categories','Resource Categories',NOW(),'instructor export course feedback');
INSERT INTO `lang_base` VALUES ('_template','resource_links','Resource Links',NOW(),'instructor export course feedback');
INSERT INTO `lang_base` VALUES ('_template','response_text','The following answers were given in response to:',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','restore','Restore',NOW(),'preferences page (removed 1.2)');
INSERT INTO `lang_base` VALUES ('_template','restore_backup','Restore Backup',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','restore_backup_about','You can use a backup you created previously in ATutor to restore content for this course - current content will be replaced with the old content.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','restore_course','Restore course',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','resubmit','Resubmit',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','result','Result',NOW(),'single result in search engine');
INSERT INTO `lang_base` VALUES ('_template','results','Results',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','results_for','Statistics for %s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','results_found','%s Results Found',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','results_from','Results from %s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','resume','Resume',NOW(),'alt/link text for the resume arrow');
INSERT INTO `lang_base` VALUES ('_template','return','Return',NOW(),'escape from delete course function');
INSERT INTO `lang_base` VALUES ('_template','revision','Revision',NOW(),'instructor content editor statistics below embedded links');
INSERT INTO `lang_base` VALUES ('_template','right','Right',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','role','Role',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','roles_privileges','Role &amp; Privileges',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','same_course_users','Only users in the same courses as you are listed.',NOW(),'inbox send message form');
INSERT INTO `lang_base` VALUES ('_template','saveclose','Save and Close',NOW(),'Save and close content Editor');
INSERT INTO `lang_base` VALUES ('_template','save_changes','Save Changes',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','save_changes_saved','All changes have been saved.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','save_changes_unsaved','Unsaved changes have been made.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','save_content','Save Content [Alt-s]',NOW(),'add/edit content submit button text');
INSERT INTO `lang_base` VALUES ('_template','save_default_prefs','Save current settings as course default preferences',NOW(),'instructor course preferences');
INSERT INTO `lang_base` VALUES ('_template','save_default_prefs_how','<p>Your current preference settings can be applied as the default preferences for this course. To adjust your settings, follow the <a href=\"users/preferences.php\">Preferences</a> link in the  Member Navigation bar, or through the Tools page.  When you are satisfied with your preferences, return here to save them as the <em>Course Default Preferences</em> by using the link below.</p>\r\n\r\n<p>Course default preferences will be used for students in the course who have not yet set their own preferences.  Preferences set by an individual will override the course default preference, allowing students to configure ATutor to suit their own needs.  When <em>Course Default Preferences</em> has been set, it will appear as an option in the Preset Preferences selector.  Also, when a student enters your course, an announcement is displayed suggesting that they use the <em>Course Default Preferences</em> preset for their preferences.</p>',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','save_styles','Save Course Styles.',NOW(),'stylesheet editor submit button text');
INSERT INTO `lang_base` VALUES ('_template','save_test_properties','Save Properties',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','save_test_question','Save Question',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search','Search',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','search_all_words','All words',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search_any_word','Any word',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search_by','Search By',NOW(),'Course Search Filter');
INSERT INTO `lang_base` VALUES ('_template','search_courses','Search Courses',NOW(),'Search Courses');
INSERT INTO `lang_base` VALUES ('_template','search_in','Search in',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search_links','Search Links',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','search_match','Match',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search_matches','matches',NOW(),'links database ');
INSERT INTO `lang_base` VALUES ('_template','search_results','Search Results',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','search_returns','Search Returns',NOW(),'links database (?)');
INSERT INTO `lang_base` VALUES ('_template','search_text','Search through the content of this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','search_words','Words',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','see','See',NOW(),'glossary - \"see\" related terms');
INSERT INTO `lang_base` VALUES ('_template','select','Select',NOW(),'print compiler');
INSERT INTO `lang_base` VALUES ('_template','select_action','Select Action',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','select_all','Select All to Display',NOW(),'print compiler');
INSERT INTO `lang_base` VALUES ('_template','select_category_to_edit','Select a Category below to edit:',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','select_display','Display Selected Content',NOW(),'print compiler');
INSERT INTO `lang_base` VALUES ('_template','select_member','Select a Member to View',NOW(),'instructor course tracker');
INSERT INTO `lang_base` VALUES ('_template','select_preset','Select Preset',NOW(),'preferences');
INSERT INTO `lang_base` VALUES ('_template','select_topic_first','Select Topic First',NOW(),'local menu message when the course content has not yet been accessed');
INSERT INTO `lang_base` VALUES ('_template','self_marking','Automatically (e.g. practice)',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','send','Send',NOW(),'global message send button text');
INSERT INTO `lang_base` VALUES ('_template','send_course_email','Send Course Email',NOW(),'instructor course email button text');
INSERT INTO `lang_base` VALUES ('_template','send_delete','Send & Delete',NOW(),'send a message from the inbox and delete the original');
INSERT INTO `lang_base` VALUES ('_template','send_message','Send Message',NOW(),'inbox send message button text');
INSERT INTO `lang_base` VALUES ('_template','send_private_message','Send a private message to another member. <a href=\"users/inbox.php\">Your message inbox</a>.',NOW(),'inbox');
INSERT INTO `lang_base` VALUES ('_template','send_to','Send email message to <i>%s</i> students.',NOW(),'instructor course email form');
INSERT INTO `lang_base` VALUES ('_template','sent_via_atutor','Sent via an ATutor system at %s',NOW(),'global email message footer');
INSERT INTO `lang_base` VALUES ('_template','sequence','Sequence',NOW(),'context (removed 1.2)');
INSERT INTO `lang_base` VALUES ('_template','seq_links','Sequence Links',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','seq_nav','Sequence Navigation',NOW(),'preferences screen');
INSERT INTO `lang_base` VALUES ('_template','server_configuration','Server Configuration',NOW(),'admin area');
INSERT INTO `lang_base` VALUES ('_template','session_end','and ended on',NOW(),'tracker - to be updated ( started on [date] and ended on [date])');
INSERT INTO `lang_base` VALUES ('_template','session_start','Session above started on',NOW(),'tracker (to be updated)');
INSERT INTO `lang_base` VALUES ('_template','set','Set',NOW(),'admin language manager');
INSERT INTO `lang_base` VALUES ('_template','set_lang_to_modify','Set Language to Modify',NOW(),'language manager');
INSERT INTO `lang_base` VALUES ('_template','set_prefs','Set Preferences [Alt-s]',NOW(),'preference screen submit button');
INSERT INTO `lang_base` VALUES ('_template','set_preset','Apply Preset',NOW(),'preferences');
INSERT INTO `lang_base` VALUES ('_template','shortcuts','Shortcuts',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','short_paragraph','Short Paragraph',NOW(),'test manager test type');
INSERT INTO `lang_base` VALUES ('_template','show_breadcrumbs','Show Breadcrumbs',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','show_headings','Show Heading Navigation',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','show_help','Show ATutor Help',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','show_marked','Show only Marked tests',NOW(),'instructor test manager');
INSERT INTO `lang_base` VALUES ('_template','show_marked_unmarked','Show Marked and Unmarked tests',NOW(),'instructor test manager');
INSERT INTO `lang_base` VALUES ('_template','show_mini_help','Show ATutor Pop-Up Help',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','show_numbers','Show Topic Numbering',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','show_raw_tracking','Show raw tracking',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','show_summary_tracking','Show summary tracking',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','show_unmarked','Show only Unmarked tests',NOW(),'instructor test manager');
INSERT INTO `lang_base` VALUES ('_template','sitemap','Site-map',NOW(),'global site-map text');
INSERT INTO `lang_base` VALUES ('_template','sitemap_text','Browse the entire course from one place.',NOW(),'tools site-map description');
INSERT INTO `lang_base` VALUES ('_template','size','Size',NOW(),'file manager, zip tool');
INSERT INTO `lang_base` VALUES ('_template','skip_index','Skip over Glossary index.',NOW(),'Alt text for bypass link on the glossary screen');
INSERT INTO `lang_base` VALUES ('_template','smile_angry','angry',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_confused','confused',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_crazy','crazy',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_evil','evil',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_frown','frown',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_lol','laughing out loud',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_muah','muah',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_oh_well','oh well',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_smile','smile',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_tired','tired',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_tongue','tongue',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','smile_wink','wink',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','special_instructions','Special Instructions',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','specify_url_to_content_package','Or, Specify a URL to a Content Package',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','started_by','Started By',NOW(),'forums thread display table column header');
INSERT INTO `lang_base` VALUES ('_template','start_date','Start Date',NOW(),'mytests, test manager');
INSERT INTO `lang_base` VALUES ('_template','start_over','Start Over',NOW(),'reset button text for inbox send message form');
INSERT INTO `lang_base` VALUES ('_template','start_section','To Beginning of Section',NOW(),'instructor add/edit content');
INSERT INTO `lang_base` VALUES ('_template','statement','Statement',NOW(),'test manager add/edit questions');
INSERT INTO `lang_base` VALUES ('_template','statistics','Statistics',NOW(),'instructor course statistics/details');
INSERT INTO `lang_base` VALUES ('_template','status','Status',NOW(),'test manager, control center, profile, admin user manager');
INSERT INTO `lang_base` VALUES ('_template','status_ascending','Order by Status Ascending',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','status_descending','Order by Status Descending',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','sticky_thread','Sticky Thread - always at the top',NOW(),'instructor forum option alt text');
INSERT INTO `lang_base` VALUES ('_template','street_address','Street Address',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','student','Student',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','student1','Student',NOW(),'admin user manager');
INSERT INTO `lang_base` VALUES ('_template','students','Students',NOW(),'course email (removed 1.2)');
INSERT INTO `lang_base` VALUES ('_template','student_id','Student ID',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','style_editor','Stylesheet Editor',NOW(),'tool page/ stylesheet editor heading text');
INSERT INTO `lang_base` VALUES ('_template','style_editor_text','Create and edit this course\'s custom style sheet. Some CSS knowledge is required.',NOW(),'tools page style editor description');
INSERT INTO `lang_base` VALUES ('_template','subject','Subject',NOW(),'global message subject label');
INSERT INTO `lang_base` VALUES ('_template','submissions','Submissions',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','submissions_for','Submissions for %s',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','submit','Submit',NOW(),'global submit button text');
INSERT INTO `lang_base` VALUES ('_template','submit_resource','Submit Resource',NOW(),'links database submit link form');
INSERT INTO `lang_base` VALUES ('_template','submit_test','Submit Test',NOW(),'mytests take test link text');
INSERT INTO `lang_base` VALUES ('_template','submit_test_results','Submit Test Results',NOW(),'test manager, mark test submit button text');
INSERT INTO `lang_base` VALUES ('_template','subscribe','Subscribe to this thread to receive notification via email of new replies.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','subscription','Subscription',NOW(),'forum subcribe function link text');
INSERT INTO `lang_base` VALUES ('_template','sub_created','New subcategory created',NOW(),'link database (?)');
INSERT INTO `lang_base` VALUES ('_template','sub_delete_error','Error Deleting Submission',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','sub_page','Add Sub Topic',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','suggestion_approved','Suggestion Approved',NOW(),'links database after approving new submission');
INSERT INTO `lang_base` VALUES ('_template','suggestion_deleted','Suggestion Deleted',NOW(),'links database after deleting a submission');
INSERT INTO `lang_base` VALUES ('_template','suggestion_error','Suggestion Error',NOW(),'links database (?)');
INSERT INTO `lang_base` VALUES ('_template','suggestion_not_accepted','Suggestion not accepted',NOW(),'link database feedback for incomplete submission');
INSERT INTO `lang_base` VALUES ('_template','suggestion_submitted','Suggestion Submitted',NOW(),'links database feedback for successfully submission ');
INSERT INTO `lang_base` VALUES ('_template','suggestion_submitted_approval','Suggestion submitted for approval',NOW(),'links database feedback for successful student submission');
INSERT INTO `lang_base` VALUES ('_template','suggest_new_link','Suggest a new link',NOW(),'links database link text at bottom of category pages');
INSERT INTO `lang_base` VALUES ('_template','summary','Summary',NOW(),'course tracker member picker');
INSERT INTO `lang_base` VALUES ('_template','switch_text','Switch to text editor',NOW(),'Content editor');
INSERT INTO `lang_base` VALUES ('_template','switch_visual','Switch to visual editor',NOW(),'Used in content editor');
INSERT INTO `lang_base` VALUES ('_template','sysadmin_login','ATutor System Administrator Login',NOW(),'admin login page heading');
INSERT INTO `lang_base` VALUES ('_template','system_contact','ATutor System Administrator Contact Form',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','table_of_contents','Table of Contents',NOW(),'preferences');
INSERT INTO `lang_base` VALUES ('_template','take_test','Take Test',NOW(),'MyTests');
INSERT INTO `lang_base` VALUES ('_template','taught_course','Taught Courses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','taught_courses2','Taught Courses',NOW(),'taught course section for non-instructors');
INSERT INTO `lang_base` VALUES ('_template','tech_support_forum','Technical Support Forum',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','tech_support_forum_text','Support questions should be of a technical nature. Course related questions should be directed to the course <a href=\"discussions/\">forums</a> or the course instructor.',NOW(),'help');
INSERT INTO `lang_base` VALUES ('_template','tests','Tests &amp; Surveys',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_anonymous','This test/survey is anonymous.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_lk','Likert',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_manager','Test &amp; Survey Manager',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_manager_text','Create and manage this course\'s online tests &amp; surveys.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_mc','Multiple Choice',NOW(),'test manager question type');
INSERT INTO `lang_base` VALUES ('_template','test_open','Open Ended',NOW(),'test manager question type');
INSERT INTO `lang_base` VALUES ('_template','test_results','Test/Survey Results',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_tf','True or False',NOW(),'test manager question type');
INSERT INTO `lang_base` VALUES ('_template','test_type','Marking',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_type_automatic','automatic',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_type_random','random',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','test_type_survey','survey',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','text','Text',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','text_and_icons','Text & Icons',NOW(),'preference option');
INSERT INTO `lang_base` VALUES ('_template','text_only','Text only',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','theme','Theme',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','themes','Themes',NOW(),'preferences');
INSERT INTO `lang_base` VALUES ('_template','themes_disabled','The personal theme preference has been disabled in favour of theme specific categories.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','this_course_only','This course only',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','this_is_content','This is just a blank content page. You can edit or delete this page by enabling the Editor and using the options directly above.',NOW(),'default content insert when a new course is created');
INSERT INTO `lang_base` VALUES ('_template','thread_already_subscribed','You are already subscribed to this thread.',NOW(),'forum view thread subscribe feedback');
INSERT INTO `lang_base` VALUES ('_template','thread_locked','Thread Locked',NOW(),'forum thread view thread lock message');
INSERT INTO `lang_base` VALUES ('_template','thread_messages','Messages',NOW(),'Header for messages in forum thread');
INSERT INTO `lang_base` VALUES ('_template','thread_notice1','A thread on the ATutor course',NOW(),'forum (removed after v1.1) see forum_new_submsg');
INSERT INTO `lang_base` VALUES ('_template','thread_notice2','has recieved a reply. Login to access the',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notice3','forum and view the',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notice4','thread.',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notify1','Thread Notification',NOW(),'forum subject line for email notification');
INSERT INTO `lang_base` VALUES ('_template','thread_notify2','A thread on the ATutor course',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notify3','has recieved a reply. Login to access the',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notify4','forum and view the',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_notify5','thread.',NOW(),'forum (removed after v1.1)');
INSERT INTO `lang_base` VALUES ('_template','thread_subscribe','Subscribe to this thread to receive notification via email of replies.',NOW(),'forum thread subscribe description');
INSERT INTO `lang_base` VALUES ('_template','tile_any_field','Any Field',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_author','Author',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_description','Description',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_export','Export content to the TILE repository. A valid TILE account is required.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_import_content_package_about','Import the content directly into this course.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_keyword','Keyword',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_progress','TILE Importing in Progress...',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_search','TILE Repository Search',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_search_text','Search the TILE repository for content to download or import.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_technical_format','Technical Format',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tile_title','Title',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','title','Title',NOW(),'admin course manager column heading');
INSERT INTO `lang_base` VALUES ('_template','title_ascending','Order by Title Ascending',NOW(),'admin course manager column heading title text');
INSERT INTO `lang_base` VALUES ('_template','title_descending','Order by Title Descending',NOW(),'admin course manager column heading title text');
INSERT INTO `lang_base` VALUES ('_template','to','To',NOW(),'inbox send message \"to\" a user');
INSERT INTO `lang_base` VALUES ('_template','to1','to',NOW(),'login form header row login -to- some place');
INSERT INTO `lang_base` VALUES ('_template','toggle_disabled','Toggle Disabled',NOW(),'alt text for menu toggle');
INSERT INTO `lang_base` VALUES ('_template','tools','Tools',NOW(),'global tools link/title text');
INSERT INTO `lang_base` VALUES ('_template','tools_details','Details for Tool Usage',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','tools_shortcut','Shortcut to Instructor Tools',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','tool_summary','Tools Usage Summary',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','top','Top',NOW(),'global alt text for jump to top link/icon');
INSERT INTO `lang_base` VALUES ('_template','topic','Topic',NOW(),'forum thread list column heading');
INSERT INTO `lang_base` VALUES ('_template','top_bottom','Top and bottom',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','total','Total',NOW(),'instructor course statistic/details, test manager');
INSERT INTO `lang_base` VALUES ('_template','to_2','to',NOW(),'test manager date');
INSERT INTO `lang_base` VALUES ('_template','to_email','To Email',NOW(),'help admin/instructor contact forms');
INSERT INTO `lang_base` VALUES ('_template','to_name','To Name',NOW(),'help admin/instructor contact forms');
INSERT INTO `lang_base` VALUES ('_template','tracker_click_path','Jump to click path.',NOW(),'mytracker jump to click path bypass link alt text');
INSERT INTO `lang_base` VALUES ('_template','tracker_none_viewed','No content pages have been viewed in this course yet.',NOW(),'mytracker summary view');
INSERT INTO `lang_base` VALUES ('_template','tracker_not_viewed','Jump to pages not yet viewed.',NOW(),'mytracker bypass to not viewed alt text');
INSERT INTO `lang_base` VALUES ('_template','tracker_pages_total','Total pages in this course %s (pages visited: %s.)',NOW(),'tracker summary pages read');
INSERT INTO `lang_base` VALUES ('_template','tracker_percent_read','Percentage of pages viewed %s.',NOW(),'tracker pages read');
INSERT INTO `lang_base` VALUES ('_template','tracker_summary_read','Summary of pages viewed by user %s.',NOW(),'tracker summary read');
INSERT INTO `lang_base` VALUES ('_template','tracking','Tracking',NOW(),'admin course manager ');
INSERT INTO `lang_base` VALUES ('_template','tracking_all_page_viewed','All pages in this course have been viewed.',NOW(),'mytracker page not viewed');
INSERT INTO `lang_base` VALUES ('_template','tracking_ascending','Order by Tracking Ascending',NOW(),'admin course manager column heading title text');
INSERT INTO `lang_base` VALUES ('_template','tracking_descending','Order by Tracking Descending',NOW(),'admin course manager column heading title text');
INSERT INTO `lang_base` VALUES ('_template','transcripts','Transcripts',NOW(),'achat entry page');
INSERT INTO `lang_base` VALUES ('_template','translate_to','Translate to:',NOW(),'footer');
INSERT INTO `lang_base` VALUES ('_template','true','True',NOW(),'test manager question answer option');
INSERT INTO `lang_base` VALUES ('_template','type','Type',NOW(),'test manager questions column heading');
INSERT INTO `lang_base` VALUES ('_template','uncategorized_courses','Uncategorized Courses:',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','underline','Underline',NOW(),'global code picker');
INSERT INTO `lang_base` VALUES ('_template','underscore','Underscore',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','unknown','Unknown',NOW(),'links database , file upload progress window');
INSERT INTO `lang_base` VALUES ('_template','unknown_error','An unknown error occured',NOW(),'general catch all error message');
INSERT INTO `lang_base` VALUES ('_template','unlimited','Unlimited',NOW(),'admin course properties & file manager');
INSERT INTO `lang_base` VALUES ('_template','unlock','Unlock',NOW(),'forums instructor lock screen');
INSERT INTO `lang_base` VALUES ('_template','unlock_thread','Unlock Thread',NOW(),'forum instructor lock screen');
INSERT INTO `lang_base` VALUES ('_template','unmarked','Unmarked',NOW(),'mytests, test manager');
INSERT INTO `lang_base` VALUES ('_template','unsubscribe','UnSubscribe from this thread to cancel receiving notifications via email of new replies.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','unvisited_pages','You have not viewed the following pages:',NOW(),'mytracker summary');
INSERT INTO `lang_base` VALUES ('_template','updated','Updated',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','update_course_properties','Update Course Properties',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','update_error','Update Error',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','update_failed','Update failed',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','update_profile','Update Profile',NOW(),'profile');
INSERT INTO `lang_base` VALUES ('_template','update_properties','Update Properties',NOW(),'admin course manager');
INSERT INTO `lang_base` VALUES ('_template','update_resources','Update Resources',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','update_status','Update Status',NOW(),'admin user manager profile editor');
INSERT INTO `lang_base` VALUES ('_template','update_submitted','Updated entry submitted for approval',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','upload','Upload',NOW(),'global upload button/link text');
INSERT INTO `lang_base` VALUES ('_template','upload_and_restore_course_backup','Upload and Restore Course Backup',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','upload_content_package','Upload a Content Package',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','upload_progress','File Upload in Progress...',NOW(),'file upload progress window');
INSERT INTO `lang_base` VALUES ('_template','url','URL',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','usaved_changes_made','Unsaved changes made',NOW(),'editing content');
INSERT INTO `lang_base` VALUES ('_template','user','User',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','user2','submitted this link in category',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','username','Username',NOW(),'global username label/link text');
INSERT INTO `lang_base` VALUES ('_template','username_ascending','Order by Username Ascending',NOW(),'admin user manager column heading title text');
INSERT INTO `lang_base` VALUES ('_template','username_descending','Order by Username Descending',NOW(),'admin user manager column header title text');
INSERT INTO `lang_base` VALUES ('_template','users','Users',NOW(),'forum, admin user manager');
INSERT INTO `lang_base` VALUES ('_template','users_online','Users Online',NOW(),'discussions page text');
INSERT INTO `lang_base` VALUES ('_template','users_online_text','Click on a name in the User\'s Online list to send that person a private message. \"Users Online\" also appears with the menus, so you can have it open at all times.',NOW(),'discussions page usres online description');
INSERT INTO `lang_base` VALUES ('_template','user_privileges','Privileges',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','user_role','Role',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','use_enrol_button','Use the button below to enroll in this course.',NOW(),'enrol screen instruction');
INSERT INTO `lang_base` VALUES ('_template','use_parent_theme','Use parent category\'s theme.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','version','Version',NOW(),'copyright notice in footer');
INSERT INTO `lang_base` VALUES ('_template','view','View',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','view_courses_taught','View Taught Courses',NOW(),'view instructor\'s courses');
INSERT INTO `lang_base` VALUES ('_template','view_entire_post','View Entire Post',NOW(),'forum message view');
INSERT INTO `lang_base` VALUES ('_template','view_mark_test','View & Mark Test',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','view_post','View Post',NOW(),'forum message view');
INSERT INTO `lang_base` VALUES ('_template','view_responses','View Responses',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','view_results','View Results',NOW(),'mytests, test manager');
INSERT INTO `lang_base` VALUES ('_template','view_tracking','View Tracking',NOW(),'tracker');
INSERT INTO `lang_base` VALUES ('_template','visits','Visits',NOW(),'tracker summary read');
INSERT INTO `lang_base` VALUES ('_template','vote_to_see_results','Vote to see results.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','warning','Warning',NOW(),'text for warning message');
INSERT INTO `lang_base` VALUES ('_template','web_server','Web Server',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','web_site','Web Site',NOW(),'registration, profile');
INSERT INTO `lang_base` VALUES ('_template','weight','Weight',NOW(),'test manager');
INSERT INTO `lang_base` VALUES ('_template','welcome_to_atutor','Welcome To ATutor',NOW(),'announcement default heading for new course');
INSERT INTO `lang_base` VALUES ('_template','window_auto_close','This window will close automatically.',NOW(),'file upload progress window');
INSERT INTO `lang_base` VALUES ('_template','wrong_answer','Wrong Answer',NOW(),'test manager question editor');
INSERT INTO `lang_base` VALUES ('_template','year','Year',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','yes','yes,',NOW(),'preferences, admin course manager');
INSERT INTO `lang_base` VALUES ('_template','yes1','Yes',NOW(),'test manager question editor');
INSERT INTO `lang_base` VALUES ('_template','yes_delete','Yes / Delete',NOW(),'global delete response option');
INSERT INTO `lang_base` VALUES ('_template','your_email','Your Email',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','your_name','Your Name',NOW(),'links database');
INSERT INTO `lang_base` VALUES ('_template','you_are_here','You are here',NOW(),'ALT text Global/Local Navigation link to self');
INSERT INTO `lang_base` VALUES ('_template','you_have_messages','You have unread messages in your Inbox',NOW(),'title text for inbox icon/link in login bar');
INSERT INTO `lang_base` VALUES ('_template','zip_archive','Zip Archive',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','zip_file_manager','Zip File Manager',NOW(),'file manager');
INSERT INTO `lang_base` VALUES ('_template','zip_illegal_contents','The contents of this archive are listed below. Illegal file types will not be extracted, and file names containing illegal characters will be translated.',NOW(),'');
INSERT INTO `lang_base` VALUES ('_template','zip_manager','Zip File Manager',NOW(),'file manager');
